C  --- FILE LEEDCON.M3 ---                                              160691
C  LEED MAIN PROGRAMS + INPUT DATA FOR SURFACES WITH 3 ATOMS PER UNIT
C  CELL
C
C
C --- M3.1.1
C  MAIN + DATA FOR W(100)+(1*1)2H, RSP, RFS, 2 MIRROR PLANES, 3 AT.U.C.
C  MAIN LEED PROGRAM FOR A (1*1)2H BRIDGE-SITE OVERLAYER ON
C  FCC OR BCC (100). SMALL OVERLAYER SPACINGS AND UNEQUAL W-H
C  BOND LENGTHS ARE ALLOWED. RSP IS APPLIED TO A COMPOSITE LAYER
C  (W+2H). RFS STACKS LAYERS. TWO ORTHOGONAL MIRROR PLANES ARE
C  ASSUMED. TOP SUBSTRATE LAYER SPACING VARIABLE
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASW(3)
C  1=NL,45=KLM
      COMPLEX VL(1,2),FLMS(1,45),FLM(45)
C  1(1ST DIMENSION)=NL=NL1*NL2, 4(2ND DIMENSION)=IDEG
      DIMENSION V(1,2),JJS(1,4)
C  1=KNBS=NO. OF BEAM SETS READ IN, 19=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(1),NB(1),SPQF(2,19),SPQ(2,19),PQF(2,19),PQ(2,19)
      INTEGER KSYM(2,19),SYM(2,19)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  3=NLAY, 12 FIXED, 759=NCAA FROM DATA STATEMENT.
      DIMENSION FPOS(3,3),VPOS(20,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20),POS(3,3)
C  3=NLAY, 3=NLAY2
      DIMENSION POSS(3,3),MGH(3,3),DRL(3,3),SDRL(3,3),NUGH(3),NGEQ(3),
     1NGOL(3),TEST(3)
C  809=NLM FROM DATA STATEMENT, 81=NN, 9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(809),YLM(81),FAC2(81),FAC1(9)
C  9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP(9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX RTM(19,19),TTM(19,19)
      COMPLEX RTP(19,19),TTP(19,19)
C  19=KNP
      COMPLEX RA1(19,19),TA1(19,19),RA2(19,19),TA2(19,19)
C  50=LMT, 15=LEV, 150(IN GH)=LMG, 3=NLAY, 75(IN TS)=LMN, 150=LM2N
C  TH AND IPL NOT USED (NO INVERSION)
      COMPLEX TAU(50,15),TAUG(50),TAUGM(50),GH(150,25),RG(3,3,19),
     1TS(75),TG(2,150),VT(150),TH(1,1)
      DIMENSION IPL(1)
C  15=LEV, 10=LOD
      COMPLEX AMULT(19),CYLM(19,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(19)
C  10 FIXED (FOR RFS2OV), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(19),PK(19,10),AW(19,2),ANEW(19,20)
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2              1560
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV                         1600
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)                    1760
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)                        1910
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =    1920
     1 ,F9.4)                                                               1930
  390 FORMAT(8H0TEMP = ,F9.4)                                               1940
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)                                                 1970
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)                                       2000
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY=NO. OF SUBPLANES IN COMPOSITE LAYER (0,IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)                                       2960
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE                                              3120
      IF (EI)  1000, 690, 690                                               3130
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI                                                                3140
      EC = E                                                                3150
      E3 = E                                                                3160
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV                                                  3170
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
      VPIS=-5.0/27.21
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)                                                 3200
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO                               3230
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI                                                                3390
  780 WRITE (6,390)  T                                                      3410
C
C
C  OVERLAYER - E BECOMES ENERGY IN OVERLAYER
      E = EC - VO                                                           3420
      E3 = E                                                                3430
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FROM PHASE SHIFTS, CORRECTED FOR
C  THERMAL VIBRATION (CAF AND TSF) OR NOT (AF AND TSF0). AF AND CAF
C  ARE USED FOR BRAVAIS-LATTICE LAYERS. TSF0 AND TSF ARE USED FOR
C  COMPOSITE LAYERS.
C  THIS CALL IS FOR OVERLAYER (IEL=2 IN INPUT SEQUENCE OF PHASE SHIFTS)
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C
C
C  CONSIDER SUBSTRATE. CHOOSE CORRECT ENERGY
      E = EC                                                                3790
      E3 = E                                                                3800
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR SUBSTRATE
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      VPI = VPIS                                                            4070
      VPI1=VPIS
C  PERFORM PLANAR LATTICE SUM IN FMAT. IF MUFFIN-TIN CONSTANTS AND
C  DAMPINGS IN SUBSTRATE AND OVERLAYER ARE EQUAL, DO LATTICE SUMS FOR
C  BOTH TYPES OF LAYERS NOW (NLS=NL IMPLIES - DO ALL SUBLATTICES).
C  OTHERWISE DO ONLY OVERLAYER LATTICE SUM (NLS=1 IMPLIES - DO ONLY THE
C  SUBLATTICE EQUAL TO THE OVERLAYER LATTICE)
      NLS = NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)             3750
C  SET PARAMETERS FOR BULK LAYERS
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA                                                              4060
C  PRODUCE REFLECTION AND TRANSMISSION MATRICES FOR SUBSTRATE
C  LAYERS. TWO REGISTRIES- ID=2. NLL=NL SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRY APPLY- LAY=2.
C  NAA=NP=NT
      NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,2,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)                                                         4150
C
C
C  NOW STACK LAYERS.
C  VARY GEOMETRY IN COMPOSITE LAYER (RELATIVE W-H POSITIONS) IN
C  LOOP 970
      DO 900 I=1,NLAY
      DO 900 J=1,3
  900 POS(I,J)=FPOS(I,J)
      NEW=+1
      DO 970 IVAR=1,NVAR
      POS(2,1)=VPOS(IVAR,1)
      POS(3,1)=VPOS(IVAR,1)
      DO 905 II=1,NLAY
      DO 904 J=1,3
  904 AS(J)=POS(II,J)*0.529
  905 WRITE(6,430)AS
C  SET PARAMETERS FOR COMPOSITE LAYER (LAY=1 FOR OVERLAYER
C  SYMMETRIES AND REGISTRY)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=1
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR COMPOSITE LAYER
      CALL MPERTI(RTP,TTP,RTM,TTM,RTP,TTP,RTP,TTP,RTP,TTP,RTP,TTP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      NEW=-1
      WRITE(6,415)
C  ASW BECOMES VECTOR BETWEEN 1ST AND 2ND SUBSTRATE LAYERS, AND WILL
C  BE VARIED BY SSTEP IN LOOP 969
      DO 936 J=1,3
  936 ASW(J)=ASB(J)
      DO 969 ISTEP=1,NSTEP
      DO 935 J=1,3
  935 AS(J)=ASW(J)*0.529
      WRITE(6,430)(AS(J),J=1,3)
      A=AS(1)
C  COMPUTE REFLECTION AMPLITUDES (XI BY RFSO2) AND INTENSITIES (AT
C  BY RINT)
      CALL RFSO2(RTP,TTP,RTM,TTM,RA1,TA1,RA2,TA2,NT,NB,KNBS,NP,
     1XI,PQ,PK,AW,ANEW,20,ASW,ASA,ASA)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
      ASW(1)=ASW(1)+STEP
  969 CONTINUE
  970 CONTINUE
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT                                                            4420
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990                                              4430
  990 E = E + DE                                                            4440
      EC = E                                                                4450
      E3 = E                                                                4460
      IF (E-EF)  700, 700, 680                                              4470
 1000 WRITE (6,450)                                                         4480
      STOP                                                                  4490
      END                                                                   4500
 W(100)+(1*1)2H, 5 PH. SH., 2 MIRROR PLANES
  4  1  1               IDEG NL1 NL2
  1 19  9               KNBS KNT NPUN
 12                     NPSI
 3.1600 0.0000          ARA1
 0.0000 3.1600          ARA2
 0.0000 0.0000          SS1
 0.5000 0.5000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 1.5800 0.0000 0.0000   ASA
 3.1600 0.0000          ARB1
 0.0000 3.1600          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 1.5800 0.0000 0.0000   ASB
 0.5000 0.4000-0.0790   FR ASE STEP
  3                     NSTEP
 19                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 1.0000 0.0000  2  2
 0.0000 1.0000  2  2
 1.0000 1.0000  9  9
 2.0000 0.0000  2  2
 0.0000 2.0000  2  2
 2.0000 1.0000  9  9
 1.0000 2.0000  9  9
 2.0000 2.0000  9  9
 3.0000 0.0000  2  2
 0.0000 3.0000  2  2
 3.0000 1.0000  9  9
 1.0000 3.0000  9  9
 3.0000 2.0000  9  9
 2.0000 3.0000  9  9
 4.0000 0.0000  2  2
 0.0000 4.0000  2  2
 4.0000 1.0000  9  9
 1.0000 4.0000  9  9
 0.0020                 TST
  1  2  3  4  5  6  7  8  9                        NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 400.0000 183.8500   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
5402.0000   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPER3 DR03
 100.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 -.8877 -.3222-2.5871  .0032  .0001  .0000  .0000  .0000  .0000  .0000
 1.7009  .0730  .0016  .0000  .0000  .0000  .0000
  .4000
-1.0151 -.4178-1.5835  .0082  .0003  .0000  .0000  .0000  .0000  .0000
 1.5782  .1091  .0032  .0001  .0000  .0000  .0000
  .5000
-1.1255 -.5032-1.0993  .0169  .0008  .0000  .0000  .0000  .0000  .0000
 1.4816  .1472  .0054  .0001  .0000  .0000  .0000
  .7500
-1.3563 -.6825 -.9244  .0612  .0042  .0002  .0000  .0000  .0000  .0000
 1.3045  .2415  .0137  .0005  .0000  .0000  .0000
 1.0000
-1.5484 -.8282 -.9594  .1479  .0127  .0009  .0001  .0000  .0000  .0000
 1.1796  .3233  .0260  .0014  .0000  .0000  .0000
 1.5000
-1.8682-1.0650-1.0764  .4547  .0565  .0060  .0006  .0000  .0000  .0000
 1.0116  .4306  .0604  .0048  .0003  .0000  .0000
 2.0000
-2.1338-1.2639-1.1761  .7973  .1489  .0205  .0026  .0003  .0000  .0000
  .9061  .4756  .1034  .0114  .0008  .0000  .0000
 3.0000
-2.5582-1.6008-1.3333 1.1383  .4604  .0950  .0180  .0028  .0004  .0000
  .7932  .4728  .1897  .0347  .0039  .0003  .0000
 4.0000
-2.8837-1.8755-1.4771 1.2583  .7767  .2267  .0591  .0129  .0023  .0003
  .7420  .4317  .2497  .0690  .0110  .0012  .0001
 5.0000
-3.1446-2.1007-1.6131 1.3196 1.0178  .3728  .1271  .0359  .0083  .0016
  .7097  .3919  .2771  .1076  .0228  .0032  .0003
 6.0000
-3.3643-2.2904-1.7352 1.3479 1.2153  .4993  .2083  .0735  .0212  .0050
  .6788  .3644  .2807  .1430  .0393  .0069  .0009
 7.0000
-3.5565-2.4564-1.8434 1.3564 1.3807  .6050  .2868  .1215  .0425  .0122
  .6457  .3497  .2716  .1702  .0589  .0126  .0019
  3                     NLAY
 0.0000 1.5800 1.5800   FPOS(1,J)
-0.6000 1.5800 0.0000   FPOS(2,J)
-0.6000 0.0000 1.5800   FPOS(3,J)
  3                     NVAR
-0.6000 0.0000 0.0000   VPOS(1,J)
-0.4000 0.0000 0.0000   VPOS(2,J)
-0.2000 0.0000 0.0000   VPOS(3,J)
  2                     NTAU
  1  2  2               LPS
  0                     NINV
  0  0                  INV
 146.00 182.00   5.00   EI EF DE
 -10.00                 EI EF DE
C  --- M3.2.1
C  MAIN + DATA FOR NI(111)+P(2*1)H, RSP (OR BEEBY) + RFS, (XZ) MIRROR PL
C  MAIN LEED PROGRAM FOR A P(2*1) OVERLAYER/UNDERLAYER ON A FCC(111)
C  SURFACE, FOR A SMALL ADSORBATE, USING RSP OR BEEBY-TYPE INVERSION FOR
C  THE LAYER COMPOSED OF THE ADATOMS AND THE ATOMS OF THE TOPMOST
C  SUBSTRATE LAYER. THE TOPMOST SUBSTRATE INTERLAYER SPACING IS VARIABLE
C  THE (XZ) PLANE IS ASSUMED TO BE A SYMMETRY PLANE (ALLOWING THETA.NE.0
C  IF FI=+-90 DEGREES). RENORMALIZED FORWARD SCATTERING IS USED TO STACK
C  LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3)
C  2=NL, 45=KLM
      COMPLEX VL(2,2),FLMS(2,45),FLM(45)
C  2=NL, 2=IDEG
      DIMENSION V(2,2),JJS(2,2)
C  2=KNBS=NO. OF BEAM SETS READ IN, 21=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(2),NB(2),SPQF(2,21),SPQ(2,21),PQF(2,21),PQ(2,21)
      INTEGER KSYM(2,21),SYM(2,21)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  3(1ST DIM)=NLAY, 20,12,7 FIXED, 759=NCAA FROM DATA STATEMENT
      DIMENSION FPOS(3,3),VPOS(20,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  3(EXCEPT 2ND DIM OF POS AND POSS)=NLAY
      DIMENSION POS(3,3),POSS(3,3),MGH(3,3)
C  3(1ST DIM)=NLAY2
      DIMENSION DRL(3,3),SDRL(3,3),NUGH(3),NGEQ(3),NGOL(3),TEST(3)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROP(21,21),TOP(21,21),ROM(21,21),TOM(21,21)
C  12=KNP
      COMPLEX RA1(21,12),TA1(21,12)
C  50=LMT, 150(IN GH)=LMG, 3(2ND DIM IN RG)=NLAY, 75(IN TS)=LMN,
C  150(IN TG)=LM2N, 75(IN TH AND IPL)=LMNI, TH AND IPL ARE NEEDED ONLY
C  IF SUBROUTINE MTINV IS USED
      COMPLEX TAU(50,15),TAUG(50),TAUGM(50),GH(150,25),RG(3,3,21),
     1TS(75),TG(2,150),VT(150)
C     COMPLEX TH(75,75)
C     DIMENSION IPL(75)
C  15=LEV, 30=LEV2, 10=LOD
      COMPLEX AMULT(21),CYLM(21,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(21)
C  8 FIXED, 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(21),PK(21,8),AW(21,2),ANEW(21,20)
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY= NO. OF SUBPLANES IN COMPOSITE LAYER (0, IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER (MPERTI AND MTINV REQUIRE THIS)
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  CONSIDER SUBSTRATE LAYERS FIRST
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPER1
      DRPAR=DRPAR1
      DR0=DR01
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. ONE REGISTRY- ID=1. NLL=NL=2 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST (NAA BEAMS)
  930 NAA = NB(1)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  SET PARAMETERS FOR COMPOSITE LAYER (OVERLAYER+TOP SUBSTRATE LAYER)
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=1
      NEW=1
C
C
C  LOOP 960 RUNS OVER ADLAYER POSITIONS VPOS IN THE COMPOSITE LAYER
      DO 960 ISTEP=1,NVAR
      DO 935 J=1,3
      AS(J)=VPOS(ISTEP,J)*0.529
  935 POS(1,J)=VPOS(ISTEP,J)
      WRITE(6,430)(AS(J),J=1,3)
      DO 936 I=2,NLAY
      DO 936 J=1,3
  936 POS(I,J)=FPOS(I,J)
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE COMPOSITE
C  LAYER BY RSP (NO PARTIAL INVERSION)
      CALL MPERTI(ROP,TOP,ROM,TOM,ROP,TOP,ROM,TOM,ROP,TOP,ROM,TOM,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      WRITE(6,415)
C  DO SAME WITH BEEBY-TYPE INVERSION ONLY INSTEAD OF RSP, IF DESIRED
C  (MAKE MATRICES TH AND IPL AVAILABLE IN DIMENSION STATEMENTS).
C  ALSO CHANGE IN INPUT
3.
C     CALL MTINV(ROP,TOP,ROM,TOM,ROP,TOP,ROM,TOM,ROP,TOP,ROM,TOM,
C    1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
C    2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,      CLM,NLM,POS,POSS,
C    3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
C    4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
C     WRITE(6,416)
C
C
C  NOW STACK LAYERS
C  ASV BECOMES VECTOR BETWEEN COMPOSITE LAYER AND 2ND SUBSTRATE LAYER,
C  AND CAN BE VARIED BY STEP IN LOOP 969
      DO 938 J=1,3
  938 ASV(J)=ASB(J)
C  IF ADLAYER IS UNDERLAYER, REDUCE SPACING BETWEEN COMPOSITE LAYER AND
C  SECOND SUBSTRATE LAYER ACCORDINGLY (ASV(1) INITIALLY IS SPACING
C  BETWEEN TOP SUBSTRATE LAYERS)
      IF (VPOS(ISTEP,1).GT.FPOS(2,1)) ASV(1)=ASV(1)-(VPOS(ISTEP,1)-
     1FPOS(2,1))
      DO 969 ISUB=1,NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      WRITE(6,430)(AS(J),J=1,3)
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSO2(ROP,TOP,ROM,TOM,RA1,TA1,RA1,TA1,NT,NB,KNBS,NP,XI,
     1PQ,PK,AW,ANEW,20,ASV,ASA,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      A=FLOAT(ISTEP)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  969 ASV(1)=ASV(1)+STEP
C
C
C  REUSE UNCHANGED QUANTITIES IN MPERTI OR MTINV IN NEXT GEOMETRY OF THE
C  COMPOSITE LAYER
  960 NEW=-1
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
--------------------------------------------------------
---- INPUT DATA FOR PRECEDING PROGRAM FOLLOW -----------
--------------------------------------------------------
 NI(111)+P(2*1)H, RSP (OR BEEBY) + RFS, 1 MIRROR PLANE, 5 PH. SH.
  2  2  1               IDEG NL1 NL2
  2 21 19               KNBS KNT NPUN
 12                     NPSI
 1.2450-2.1564          ARA1
 1.2450 2.1564          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.0330 0.0000 1.4376   ASA
 2.4900 0.0000          ARB1
 0.0000 4.3128          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0330 0.0000 1.4376   ASB
 0.5000 1.2450 0.0500   FR ASE STEP
  1                     NSTEP
 12                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 1.0000 0.0000  6  6
-1.0000 1.0000  1  1
 0.0000 1.0000  6  6
 1.0000-1.0000  1  1
 1.0000 1.0000  6  6
-1.0000 2.0000  6  6
 2.0000-1.0000  6  6
 2.0000 0.0000  6  6
-2.0000 2.0000  1  1
 0.0000 2.0000  6  6
 2.0000-2.0000  1  1
  9                     KNB(2)
-0.5000 0.5000  1  1
 0.5000-0.5000  1  1
 0.5000 0.5000  6  6
-1.5000 1.5000  1  1
-0.5000 1.5000  6  6
 0.5000 1.5000  6  6
 1.5000 0.5000  6  6
 1.5000-0.5000  6  6
 1.5000-1.5000  1  1
 0.0020                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 20 21   NPU
   0.00   0.00          THETA FI
   0.00  11.20          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 440.0000  58.7100   1.4000   1.4000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
3357.9827   1.0080   2.0000   2.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 110.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 2.8398 -.0137 -.1876  .0011  .0000  .0000  .0000  .0000   NI
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
  .4000
 2.7639 -.0216 -.3164  .0024  .0001  .0000  .0000  .0000   NI
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
  .5000
 2.6930 -.0322 -.2630  .0048  .0002  .0000  .0000  .0000   NI
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
  .7500
 2.5276 -.0668 -.2322  .0160  .0009  .0000  .0000  .0000   NI
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 1.0000
 2.3803 -.1132 -.2323  .0386  .0028  .0002  .0000  .0000   NI
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 1.5000
 2.1240 -.2247 -.2118  .1202  .0125  .0012  .0001  .0000   NI
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.0000
 1.9101 -.3448 -.1758  .2494  .0335  .0042  .0004  .0000   NI
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 3.0000
 1.5727 -.5697 -.1288  .5535  .1138  .0216  .0034  .0004   NI
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 4.0000
 1.3160 -.7574 -.1272  .7884  .2257  .0583  .0125  .0022   NI
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 5.0000
 1.1099 -.9122 -.1445  .9491  .3361  .1107  .0305  .0069   NI
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 6.0000
  .9366-1.0434 -.1666 1.0690  .4287  .1691  .0571  .0159   NI
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
 7.0000
  .7862-1.1581 -.1902 1.1630  .5045  .2251  .0894  .0297   NI
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  3                     NLAY
 0.0000 0.0000 0.0000   FPOS(1,J) NOT USED
 0.0000 0.0000 0.0000   FPOS(2,J)
 0.0000 1.2450-2.1564   FPOS(3,J)
  4                     NVAR
 1.0166 0.0000-1.4400   VPOS(1,J)
-0.2000 0.0000-1.4400   VPOS(2,J)
 0.5080 0.0000-2.8800   VPOS(3,J)
-0.2000 0.0000-2.8800   VPOS(4,J)
  2                     NTAU
  2  1  1               LPS
  0                     NINV
  0  0  0               INV
  40.00 151.00   5.00   EI EF DE
 -10.00                 EI EF DE
--------------------------------------------------------
---- FIRST PART OF PRINTER OUTPUT FOLLOWS --------------
----(NEGLECTING MOST BLANK LINES AND PAGE --------------
---- EJECTS AND TRUNCATING LONG LINES)    --------------
--------------------------------------------------------
 NI(111)+P(2*1)H, RSP (OR BEEBY) + RFS, 1 MIRROR PLANE, 5 PH. SH.
IDEG =   2 NL1 =   2 NL2 =   1
PARAMETERS FOR INTERIOR
SURF VECS       1.2450 -2.1564
                1.2450  2.1564
SS    0.0000 0.0000
SS    0.0000 0.0000
SS    0.0000 0.0000
SS    0.0000 0.0000
ASA    2.0330 0.0000 1.4376
PARAMETERS FOR SURFACE
SURF VECS       2.4900  0.0000
                0.0000  4.3128
SO     0.0000 0.0000
SO     0.0000 0.0000
SO     0.0000 0.0000
ASB    2.0330 0.0000 1.4376
FR =   .5000 ASE =  1.2450 STEP =   .0500 NSTEP =   1
         PQ1    PQ2        SYM
 
   1     0.000  0.000      1  1
   2     1.000  0.000      6  6
   3    -1.000  1.000      1  1
   4     0.000  1.000      6  6
   5     1.000 -1.000      1  1
   6     1.000  1.000      6  6
   7    -1.000  2.000      6  6
   8     2.000 -1.000      6  6
   9     2.000  0.000      6  6
  10    -2.000  2.000      1  1
  11     0.000  2.000      6  6
  12     2.000 -2.000      1  1
 
  13     -.500   .500      1  1
  14      .500  -.500      1  1
  15      .500   .500      6  6
  16    -1.500  1.500      1  1
  17     -.500  1.500      6  6
  18      .500  1.500      6  6
  19     1.500   .500      6  6
  20     1.500  -.500      6  6
  21     1.500 -1.500      1  1
TST =   .0020
PUNCHED BEAMS     1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 20 2
THETA  FI =    0.00   0.00
VO       0.00VV      11.20
EPS =   .0010  LITER =   5
IT1 =   1 IT2 =   1 IT3 =   0
THDB =  440.0000 AM =   58.7100 FPER =    1.4000 FPAR =    1.4000 DR0 =
THDB = 3357.9827 AM =    1.0080 FPER =    2.0000 FPAR =    2.0000 DR0 =
THDB =    1.0000 AM =    1.0000 FPER =    1.0000 FPAR =    1.0000 DR0 =
LMAX =   4
     PHASE SHIFTS
 
E =   .3000  1ST ELEMENT     2.8398  -.0137  -.1876   .0011  0.0000
             2ND ELEMENT     1.3979   .0211   .0003  0.0000  0.0000
 
E =   .4000  1ST ELEMENT     2.7639  -.0216  -.3164   .0024   .0001
             2ND ELEMENT     1.3321   .0320   .0006  0.0000  0.0000
 
E =   .5000  1ST ELEMENT     2.6930  -.0322  -.2630   .0048   .0002
             2ND ELEMENT     1.2785   .0440   .0010  0.0000  0.0000
 
E =   .7500  1ST ELEMENT     2.5276  -.0668  -.2322   .0160   .0009
             2ND ELEMENT     1.1743   .0772   .0025   .0001  0.0000
 
E =  1.0000  1ST ELEMENT     2.3803  -.1132  -.2323   .0386   .0028
             2ND ELEMENT     1.0944   .1125   .0050   .0001  0.0000
 
E =  1.5000  1ST ELEMENT     2.1240  -.2247  -.2118   .1202   .0125
             2ND ELEMENT      .9739   .1818   .0125   .0006  0.0000
 
E =  2.0000  1ST ELEMENT     1.9101  -.3448  -.1758   .2494   .0335
             2ND ELEMENT      .8847   .2416   .0233   .0014   .0001
 
E =  3.0000  1ST ELEMENT     1.5727  -.5697  -.1288   .5535   .1138
             2ND ELEMENT      .7610   .3215   .0527   .0049   .0003
 
E =  4.0000  1ST ELEMENT     1.3160  -.7574  -.1272   .7884   .2257
             2ND ELEMENT      .6829   .3567   .0877   .0113   .0009
 
E =  5.0000  1ST ELEMENT     1.1099  -.9122  -.1445   .9491   .3361
             2ND ELEMENT      .6334   .3644   .1227   .0207   .0022
 
E =  6.0000  1ST ELEMENT      .9366 -1.0434  -.1666  1.0690   .4287
             2ND ELEMENT      .6021   .3577   .1534   .0328   .0043
 
E =  7.0000  1ST ELEMENT      .7862 -1.1581  -.1902  1.1630   .5045
             2ND ELEMENT      .5819   .3447   .1778   .0469   .0074
COMPOSITE LAYER VECTOR
00 0.0000 0.0000
COMPOSITE LAYER VECTOR
00 0.0000 0.0000
COMPOSITE LAYER VECTOR
00 1.2450-2.1564
VARYING POSITION IN COMPOSITE LAYER
.0166 0.0000-1.4400
VARYING POSITION IN COMPOSITE LAYER
.2000 0.0000-1.4400
VARYING POSITION IN COMPOSITE LAYER
.5080 0.0000-2.8800
VARYING POSITION IN COMPOSITE LAYER
.2000 0.0000-2.8800
NTAU =   2
PHASE SHIFT ASSIGNMENT IN COMPOSITE LAYER   2  1  1
 0 SUBPLANES IN BEEBY INVERSION
  0
NO. OF ELEMENTS IN CAAA
9
ENERGY = 1.8837 H  OR   40.00 EV
 12 BEAMS USED
   7
   0.000 0.000   1.000 0.000  -1.000 1.000   0.000 1.000   1.000-1.000
  -.500 1.500   1.500 -.500   1.500-1.500
VPIS =    -.1114 VPIO =    -.1114 DCUTS =   87.1160 DCUTO =   87.1160
TEMP =  110.0000
MSMF   OK
MSMF   OK
SURFACE GEOMETRY
1.0166 0.0000-1.4400
NO. OF LATT. PTS. FOR GH
16
NO. OF LATT. PTS. FOR GH
16
NO. OF BEAMS FOR GH
X IN TPERTI =     .19742E+00   .19742E+00   .92227E-01
X IN TPERTI =     .19289E+00   .20031E+00   .11110E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .19742E+00   .19742E+00   .92227E-01
X IN TPERTI =     .19352E+00   .18844E+00   .10118E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .32950E+00   .32831E+00   .10225E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .32073E+00   .33388E+00   .10984E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .31767E+00   .31767E+00   .11940E+00
X IN TPERTI =     .32778E+00   .32955E+00   .10487E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .31767E+00   .31767E+00   .11940E+00
X IN TPERTI =     .35048E+00   .30918E+00   .11039E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .32930E+00   .32049E+00   .10229E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .31393E+00   .29124E+00   .12321E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .31767E+00   .31767E+00   .11940E+00
X IN TPERTI =     .32975E+00   .31915E+00   .10491E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .31767E+00   .31767E+00   .11940E+00
X IN TPERTI =     .31947E+00   .28182E+00   .12688E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .28682E+00   .28682E+00   .11011E+00
X IN TPERTI =     .28483E+00   .28671E+00   .11998E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .28682E+00   .28682E+00   .11011E+00
X IN TPERTI =     .29678E+00   .28060E+00   .95219E-01
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .28682E+00   .28682E+00   .11011E+00
X IN TPERTI =     .28942E+00   .28040E+00   .98745E-01
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .28682E+00   .28682E+00   .11011E+00
X IN TPERTI =     .28206E+00   .26233E+00   .11126E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .32800E+00   .32800E+00   .11477E+00
X IN TPERTI =     .32460E+00   .33002E+00   .80985E-01
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32800E+00   .32800E+00   .11477E+00
X IN TPERTI =     .30578E+00   .33408E+00   .10366E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .78131E+00   .78131E+00   .15024E+00
X IN TPERTI =     .78659E+00   .78513E+00   .99735E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .78131E+00   .78131E+00   .15024E+00
X IN TPERTI =     .13377E+01   .11155E+01   .15493E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .46587E+00   .46587E+00   .12486E+00
X IN TPERTI =     .44922E+00   .45002E+00   .17243E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .46587E+00   .46587E+00   .12486E+00
X IN TPERTI =     .54924E+00   .55929E+00   .12519E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .46587E+00   .46587E+00   .12486E+00
X IN TPERTI =     .44611E+00   .44413E+00   .14885E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .46587E+00   .46587E+00   .12486E+00
X IN TPERTI =     .48998E+00   .56797E+00   .12438E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .78131E+00   .78131E+00   .15024E+00
X IN TPERTI =     .78165E+00   .78331E+00   .61331E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .78131E+00   .78131E+00   .15024E+00
X IN TPERTI =     .99533E+00   .94266E+00   .15050E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
MPERTI OK
SURFACE GEOMETRY
1.0164 0.0000 1.4376
IMAX = 12     BNORM =    .2039E-02
ANORM =    .8267E-01
 
IMAX =  4     BNORM =    .1009E-02
ANORM =    .8301E-01
 
IMAX =  2     BNORM =    .2651E-03
ANORM =    .8302E-01
 
E=    1.8837 THETA=    0.0000 FI=    0.0000
 
   PQ1    PQ2      REF INT     SYM
 0.000  0.000   .49899E-03      1
 1.000  0.000   .10339E-01      6
-1.000  1.000   .10399E-01      1
 0.000  1.000   .13756E-02      6
 1.000 -1.000   .14041E-02      1
 -.500   .500   .27782E-04      1
  .500  -.500   .30052E-03      1
  .500   .500   .25011E-04      6
SURFACE GEOMETRY
-.2000 0.0000-1.4400
NO. OF LATT. PTS. FOR GH
20
NO. OF LATT. PTS. FOR GH
20
NO. OF LATT. PTS. FOR GH
22
NO. OF LATT. PTS. FOR GH
22
X IN TPERTI =     .92227E-01   .19742E+00   .19742E+00
X IN TPERTI =     .11818E+00   .23655E+00   .23390E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .92227E-01   .19742E+00   .19742E+00
X IN TPERTI =     .12020E+00   .22760E+00   .21330E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11663E+00   .32288E+00   .32288E+00
X IN TPERTI =     .13106E+00   .32806E+00   .32229E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11663E+00   .32288E+00   .32288E+00
X IN TPERTI =     .11393E+00   .32779E+00   .30967E+00
   CONV IN TPERTI AFTER    4 ITERATIONS
X IN TPERTI =     .11940E+00   .31767E+00   .31767E+00
X IN TPERTI =     .13566E+00   .34000E+00   .30712E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11940E+00   .31767E+00   .31767E+00
X IN TPERTI =     .11970E+00   .32056E+00   .32251E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11663E+00   .32288E+00   .32288E+00
X IN TPERTI =     .92734E-01   .30901E+00   .32597E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11663E+00   .32288E+00   .32288E+00
X IN TPERTI =     .91161E-01   .32582E+00   .33242E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11940E+00   .31767E+00   .31767E+00
X IN TPERTI =     .97972E-01   .31889E+00   .31657E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11940E+00   .31767E+00   .31767E+00
X IN TPERTI =     .99073E-01   .33200E+00   .32753E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11011E+00   .28682E+00   .28682E+00
X IN TPERTI =     .13053E+00   .26985E+00   .28936E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11011E+00   .28682E+00   .28682E+00
X IN TPERTI =     .14931E+00   .27669E+00   .27311E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11011E+00   .28682E+00   .28682E+00
X IN TPERTI =     .12371E+00   .30616E+00   .28231E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11011E+00   .28682E+00   .28682E+00
X IN TPERTI =     .12245E+00   .29798E+00   .29099E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11477E+00   .32800E+00   .32800E+00
X IN TPERTI =     .13598E+00   .30796E+00   .31033E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .11477E+00   .32800E+00   .32800E+00
X IN TPERTI =     .13271E+00   .32043E+00   .30891E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .15024E+00   .78131E+00   .78131E+00
X IN TPERTI =     .16235E+00   .87029E+00   .76832E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .15024E+00   .78131E+00   .78131E+00
X IN TPERTI =     .20852E+00   .81066E+00   .77560E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .12486E+00   .46587E+00   .46587E+00
X IN TPERTI =     .10633E+00   .48175E+00   .45824E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .12486E+00   .46587E+00   .46587E+00
X IN TPERTI =     .94376E-01   .45080E+00   .44812E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .12486E+00   .46587E+00   .46587E+00
X IN TPERTI =     .11836E+00   .44122E+00   .48589E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .12486E+00   .46587E+00   .46587E+00
X IN TPERTI =     .11449E+00   .43675E+00   .45401E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .15024E+00   .78131E+00   .78131E+00
X IN TPERTI =     .19862E+00   .80500E+00   .75692E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .15024E+00   .78131E+00   .78131E+00
X IN TPERTI =     .30437E+00   .80052E+00   .74147E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
MPERTI OK
SURFACE GEOMETRY
2.0330 0.0000 1.4376
IMAX = 12     BNORM =    .2097E-02
ANORM =    .7736E-01
 
IMAX =  3     BNORM =    .1795E-02
ANORM =    .7758E-01
 
IMAX =  2     BNORM =    .8832E-04
ANORM =    .7759E-01
 
E=    1.8837 THETA=    0.0000 FI=    0.0000
 
   PQ1    PQ2      REF INT     SYM
 0.000  0.000   .31923E-02      1
 1.000  0.000   .63228E-02      6
-1.000  1.000   .64306E-02      1
 0.000  1.000   .30378E-02      6
 1.000 -1.000   .34254E-02      1
 -.500   .500   .45687E-03      1
  .500  -.500   .15910E-02      1
  .500   .500   .13155E-02      6
SURFACE GEOMETRY
 .5080 0.0000-2.8800
NO. OF LATT. PTS. FOR GH
20
NO. OF LATT. PTS. FOR GH
20
NO. OF LATT. PTS. FOR GH
22
NO. OF LATT. PTS. FOR GH
22
X IN TPERTI =     .19742E+00   .19742E+00   .92227E-01
X IN TPERTI =     .19888E+00   .18324E+00   .11057E+00
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .19742E+00   .19742E+00   .92227E-01
X IN TPERTI =     .20240E+00   .20685E+00   .82584E-01
NO CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .33764E+00   .32921E+00   .96074E-01
   CONV IN TPERTI AFTER    5 ITERATIONS
X IN TPERTI =     .32288E+00   .32288E+00   .11663E+00
X IN TPERTI =     .30802E+00   .31179E+00   .11173E+00
   CONV IN TPERTI AFTER    5 ITERATIONS
C
C
C  --- M3.3.1
C
C     PROGRAM MNIH3(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN + DATA FOR NI(111)+(2*2)3H(PLANAR), RSP + RFS, 3-FOLD AXIS
C  MAIN LEED PROGRAM FOR A (2*2) 3 AT/UC PLANAR OVERLAYER ON A FCC(111)
C  SURFACE, USING RSP FOR THE OVERLAYER. A 3-FOLD AXIS OF SYMMETRY IS
C  ASSUMED. RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
C  TWO OVERLAYER REGISTRIES CONSIDERED.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3)
C  4=NL, 45=KLM
      COMPLEX VL(4,2),FLMS(4,45),FLM(45)
C  4=NL, 3=IDEG
      DIMENSION V(4,2),JJS(4,3)
C  2=KNBS=NO. OF BEAM SETS READ IN, 20=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(2),NB(2),SPQF(2,20),SPQ(2,20),PQF(2,20),PQ(2,20)
      INTEGER KSYM(2,20),SYM(2,20)
C  20 MUST BE .GE. NPUN
      DIMENSION NPU(20),NPUC(20)
C  12=NPSI, 10=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,10)
C  3(1ST DIM)=NLAY, 20,12,7 FIXED, 759=NCAA FROM DATA STATEMENT
      DIMENSION FPOS(3,3),VPOS(20,3),LPS(20),INV(20),CAA(759),NCA(7),
     1LPSS(20)
C  3=NLAY
      DIMENSION POS(3,3),POSS(3,3),MGH(3,3)
C  3=NLAY2
      DIMENSION DRL(3,3),SDRL(3,3),NUGH(3),NGEQ(3),NGOL(3),TEST(3)
C   809=NLM FROM DATA STATEMENT,  81=NN,  9=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM( 809),YLM( 81),FAC2( 81),FAC1( 9)
C   9=NN1, 5=NN2, 5=NN3
      DIMENSION PPP( 9,5,5)
C  25=LMMAX
      DIMENSION LX(25),LXI(25),LXM(25),LT(25)
C  5=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(5),CAF(5),TSF0(6,10),TSF(6,10)
      COMPLEX ROP(20,20),TOP(20,20)
C  14=KNP
      COMPLEX RA1(20,14),TA1(20,14),RA2(20,14),TA2(20,14),
     1RA3(20,14),TA3(20,14)
C  25=LMT, 150(IN GH)=LMG, 3(2ND DIM IN RG)=NLAY, 75(IN TS)=LMN,
C  150(IN TG)=LM2N
      COMPLEX TAU(25,15),TAUG(25),TAUGM(25),GH(150,25),RG(3,3,20),
     1TS(75),TG(2,150),VT(150)
C  15=LEV, 30=LEV2, 10=LOD
      COMPLEX AMULT(20),CYLM(20,25),XEV(15,30),XOD(10,10),
     1YLME(15),YLMO(10)
      DIMENSION IPLE(15),IPLO(10),AT(20)
C  8 FIXED, 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(20),PK(20,8),AW(20,2),ANEW(20,20)
C  FOR CDC ONLY  *********************************
C     LEVEL 2,GH,TH,TAU,XEV,XOD,ROP,TOP,RA1,TA1,RA2,TA2,RA3,TA3
      COMMON /BIG/GH,TH,TAU,XEV,XOD,ROP,TOP,RA1,TA1,RA2,TA2,RA3,TA3
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY= NO. OF SUBPLANES IN COMPOSITE LAYER (0, IF NO COMP. LAYER)
      READ(5,200)NLAY
      IF (NLAY.EQ.0) GO TO 500
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
  500 CONTINUE
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  CONSIDER SUBSTRATE LAYERS FIRST
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PRODUCE REFLECTION (RA1,2,3) AND TRANSMISSION (TA1,2,3) MATRICES FOR
C  ATOMIC LAYERS. 3 REGISTRIES- ID=3. NLL=NL=4 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST (NAA BEAMS)
  930 NAA = NB(1)
      CALL MSMF(RA1,TA1,RA2,TA2,RA3,TA3,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,3,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND (AND 3RD AND 4TH) BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS
C  NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RA1,TA1,RA2,TA2,RA3,TA3,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,3,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
C  SET PARAMETERS FOR COMPOSITE LAYER (OVERLAYER)
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=2
      NEW=1
      DO 936 I=1,NLAY
      DO 936 J=1,3
  936 POS(I,J)=FPOS(I,J)
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE COMPOSITE
C  LAYER BY RSP (NO PARTIAL INVERSION)
      CALL MPERTI(ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      WRITE(6,415)
C
C
C  NOW STACK LAYERS
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE,
C  AND CAN BE VARIED BY STEP IN LOOP 969
      DO 938 J=1,3
  938 ASV(J)=ASB(J)
      DO 960 ISTEP=1,NSTEP
      DO 940 J=1,3
  940 AS(J)=ASV(J)*0.529
      WRITE(6,430)(AS(J),J=1,3)
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSO3(ROP,TOP,ROP,TOP,RA1,TA1,RA2,TA2,RA3,TA3,NT,NB,KNBS,
     1NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      A=FLOAT(ISTEP)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
      CALL RFSO3(ROP,TOP,ROP,TOP,RA3,TA3,RA1,TA1,RA2,TA2,NT,NB,KNBS,
     1NP,XI,PQ,PK,AW,ANEW,20,ASV,ASA)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      A=FLOAT(ISTEP)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  960 ASV(1)=ASV(1)+STEP
C
C
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 NI(111)+(2*2)3H,PLANAR OVERLAYER,RSP+RFS,3-FOLD AXIS
  3  2  2               IDEG NL1 NL2
  2 20 20               KNBS KNT NPUN
 12                     NPSI
 1.2450-2.1564          ARA1
 1.2450 2.1564          ARA2
 0.0000 0.0000          SS1
 0.6667 0.3333          SS2
 0.3333 0.6667          SS3
 0.0000 0.0000          SS4
 2.0330 0.0000 0.0000   ASA
 2.4900-4.3128          ARB1
 2.4900 4.3128          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 0.5000 0.0000 0.0000   ASB
 0.5000 0.5000 0.2000   FR ASE STEP
  6                     NSTEP
  6                     KNB(1)
 0.0000 0.0000  1  1    BEAMS
 1.0000 0.0000 11 11
 0.0000 1.0000 11 11
 1.0000 1.0000 14 14
 2.0000 0.0000 11 11
 0.0000 2.0000 11 11
 14                      KNB(2)
 0.5000 0.0000 11  1
-0.5000 0.0000 11  1
-0.5000 1.0000 11  1
 0.5000-1.0000 11  1
-1.5000 1.0000 11  1
 1.5000-1.0000 11  1
 0.5000 1.0000 11  1
-0.5000-1.0000 11  1
 1.5000 0.0000 11  1
-1.5000 0.0000 11  1
-1.5000 2.0000 11  1
 1.5000-2.0000 11  1
-0.5000 2.0000 11  1
 0.5000-2.0000 11  1
 0.0020                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20   NPU
   0.00   0.00          THETA FI
   0.00  11.20          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
3357.9827   1.0080   2.0000   2.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
 440.0000  58.7100   1.4000   1.4000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 110.0000                                        TI TF DT
  4                     LMAX
  2                     NEL
  .3000
 1.3979 0.0211 0.0003 0.0000 0.0000 0.0000 0.0000
 2.8398 -.0137 -.1876  .0011  .0000  .0000  .0000  .0000   NI
  .4000
 1.3321 0.0320 0.0006 0.0000 0.0000 0.0000 0.0000
 2.7639 -.0216 -.3164  .0024  .0001  .0000  .0000  .0000   NI
  .5000
 1.2785 0.0440 0.0010 0.0000 0.0000 0.0000 0.0000
 2.6930 -.0322 -.2630  .0048  .0002  .0000  .0000  .0000   NI
  .7500
 1.1743 0.0772 0.0025 0.0001 0.0000 0.0000 0.0000
 2.5276 -.0668 -.2322  .0160  .0009  .0000  .0000  .0000   NI
 1.0000
 1.0944 0.1125 0.0050 0.0001 0.0000 0.0000 0.0000
 2.3803 -.1132 -.2323  .0386  .0028  .0002  .0000  .0000   NI
 1.5000
 0.9739 0.1818 0.0125 0.0006 0.0000 0.0000 0.0000
 2.1240 -.2247 -.2118  .1202  .0125  .0012  .0001  .0000   NI
 2.0000
 0.8847 0.2416 0.0233 0.0014 0.0001 0.0000 0.0000
 1.9101 -.3448 -.1758  .2494  .0335  .0042  .0004  .0000   NI
 3.0000
 0.7610 0.3215 0.0527 0.0049 0.0003 0.0000 0.0000
 1.5727 -.5697 -.1288  .5535  .1138  .0216  .0034  .0004   NI
 4.0000
 0.6829 0.3567 0.0877 0.0113 0.0009 0.0001 0.0000
 1.3160 -.7574 -.1272  .7884  .2257  .0583  .0125  .0022   NI
 5.0000
 0.6334 0.3644 0.1227 0.0207 0.0022 0.0002 0.0000
 1.1099 -.9122 -.1445  .9491  .3361  .1107  .0305  .0069   NI
 6.0000
 0.6021 0.3577 0.1534 0.0328 0.0043 0.0004 0.0000
  .9366-1.0434 -.1666 1.0690  .4287  .1691  .0571  .0159   NI
 7.0000
 0.5819 0.3447 0.1778 0.0469 0.0074 0.0008 0.0001
  .7862-1.1581 -.1902 1.1630  .5045  .2251  .0894  .0297   NI
  3                     NLAY
 0.0000-1.2450 0.7200   FPOS(1,J)
 0.0000 0.0000-1.4400   FPOS(2,J)
 0.0000 1.2450 0.7200   FPOS(3,J)
  0                     NVAR
 1.0166 0.0000-1.4400   VPOS(1,J)
  1                     NTAU
  1  1  1               LPS
  0                     NINV
  0  0  0               INV
  40.00  41.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C  --- M3.4.1
C
C     PROGRAM CUAL(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA CU(111)+(R3XR3)R30AL ALLOY, RSP+RFS,(XZ) MIRR.PL.
C  MAIN LEED PROGRAM FOR A (R3XR3)R30 SUBSTITUTIONALLY ALLOYED FCC(111)
C  SURFACE, USING RSP FOR THE POSSIBLY BUCKLED 3-ATOM/U.C. OVERLAYER.
C  THE (XZ) PLANE IS MIRROR PLANE.
C  RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASV2(3),ASI(3,10),STPS(3,10,2),
     3NSTS(10,2),NRTNP(1),NRTP(1)
C  3=NL, 66=KLM
      COMPLEX VL(3,2),FLMS(3,66),FLM(66)
C  3=NL, 3=IDEG
      DIMENSION V(3,2),JJS(3,3)
C  2=KNBS=NO. OF BEAM SETS READ IN, 52=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(2),NB(2),SPQF(2,52),SPQ(2,52),PQF(2,52),PQ(2,52)
      INTEGER KSYM(2,52),SYM(2,52)
C  106 MUST BE .GE. NPUN
      DIMENSION NPU(106),NPUC(106)
C  12=NPSI, 12=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,12)
C  3(1ST DIM)=NLAY, 20,12,7 FIXED, 1820=NCAA FROM DATA STATEMENT
      DIMENSION FPOS(3,3),VPOS(20,3),LPS(20),INV(20),CAA(1820),NCA(7),
     1LPSS(20)
C  3=NLAY
      DIMENSION POS(3,3),POSS(3,3),MGH(3,3)
C  3=NLAY2
      DIMENSION DRL(3,3),SDRL(3,3),NUGH(3),NGEQ(3),NGOL(3),TEST(3)
C  1925=NLM FROM DATA STATEMENT, 121=NN, 11=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(1925),YLM(121),FAC2(121),FAC1(11)
C  11=NN1, 6=NN2, 6=NN3
      DIMENSION PPP(11,6,6)
C  36=LMMAX
      DIMENSION LX(36),LXI(36),LXM(36),LT(36)
C  6=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(6),CAF(6),TSF0(6,10),TSF(6,10)
      COMPLEX ROP(52,52),TOP(52,52),ROM(52,52),TOM(52,52)
C  30=KNP
      COMPLEX RA1(52,30),TA1(52,30)
C  72=LMT, 216(IN GH)=LMG, 3(2ND DIM IN RG)=NLAY, 108(IN TS)=LMN,
C  216(IN TG)=LM2N
      COMPLEX TAU(72,21),TAUG(72),TAUGM(72),GH(216,36),RG(3,3,52),
     1TS(108),TG(2,216),VT(216)
C  21=LEV, 42=LEV2, 15=LOD
      COMPLEX AMULT(52),CYLM(52,36),XEV(21,42),XOD(15,15),
     1YLME(21),YLMO(15)
      DIMENSION IPLE(21),IPLO(15),AT(52)
C  6=MNPP, 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(52),PK(52,6),AW(52,2),ANEW(52,20)
C  FOR CDC ONLY  *********************************
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
C     COMMON /BIG/ GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON/NST/NST1,ASI,STPS,NSTS,NACV
      COMMON/ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     *IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN
     * ,BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  170 FORMAT(3F7.4,2(I3,3F7.4))
  171 FORMAT(7H ASI = ,3F8.4,/,2(10X,7HNSTS = ,I3,8H STPS = ,3F8.4,/))
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
      WRITE(8,465)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY= NO. OF SUBPLANES IN COMPOSITE LAYER (0, IF NO COMP. LAYER)
      READ(5,200)NLAY,NST1,ISCAN
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
      WRITE (8,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  CONSIDER SUBSTRATE LAYERS FIRST
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. 1 REGISTRY- ID=1. NLL=NL=3 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST (NAA BEAMS)
  930 NAA = NB(1)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND (AND 3RD) BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS
C  NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  SET PARAMETERS FOR COMPOSITE LAYER (OVERLAYER)
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=5
      NOPT=1
      NEW=1
C  SCAN OVER STRUCTURES WITHIN OVERLAYER
      DO 975 IVAR=1,NVAR
      DO 934 I=1,NLAY
      DO 933 J=1,3
      FPOS(3,J)=VPOS(IVAR,J)
  933 AS(J)=FPOS(I,J)*0.529
      WRITE(6,430)AS
  934 WRITE(8,430)AS
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE COMPOSITE
C  LAYER BY RSP (NO PARTIAL INVERSION)
      CALL MPERTI(ROP,TOP,ROM,TOM,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
      WRITE(6,415)
C
C
C  NOW STACK LAYERS
      NRTNP(1)=1
      NRTP(1)=101
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE
      DO 970 NSC=1,NACV
      CALL GEOMV(0,1,FPOS,NLAY,NSC,ASV)
      A=ASV(1)*0.529
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSG(ROP,TOP,ROM,TOM,RA1,TA1,RA1,TA1,NT,NP,1,1,NRTNP,1,NRTP,
     11,NT,NB,KNBS,XI,PQ,PK,6,AW,ANEW,20,ASV,ASA,1,6,0.003)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  970 CONTINUE
  975 CONTINUE
C
C
      WRITE(8,370)E,EEV
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
 CU(111)+(R3XR3)R30AL ALLOY,RSP+RFS,(XZ) MIRR.PL.
  3  3  1               IDEG NL1 NL2
  2 52 18               KNBS KNT NPUN
 12                     NPSI
 1.2780-2.2136          ARA1
 1.2780 2.2136          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.0870 0.0000-1.4757   ASA
 3.8340-2.2136          ARB1
 3.8340 2.2136          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 2.0000 0.0000 0.0000   ASB
 0.5000 1.3000 0.0000   FR ASE STEP
  0                     NSTEP
 22                     KNB(1)
 0.     0.      1  1
 0.     1.0000  6  6
 0.    -1.0000  6  6
-1.0000 1.0000  1  1
 1.0000-1.0000  1  1
 1.0000 1.0000  6  6
-1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 0.     2.0000  6  6
 0.    -2.0000  6  6
-2.0000 2.0000  1  1
 2.0000-2.0000  1  1
 1.0000 2.0000  6  6
-1.0000-2.0000  6  6
-1.0000 3.0000  6  6
 1.0000-3.0000  6  6
-2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 0.     3.0000  6  6
 0.    -3.0000  6  6
-3.0000 3.0000  1  1
 3.0000-3.0000  1  1
 30                     KNB(2)
  .3333  .3333  6  1
  .3333 -.6667  6  1
 -.6667  .3333  6  1
 -.6667 -.6667  6  1
 -.6667 1.3333  6  1
 1.3333 -.6667  6  1
  .3333 1.3333  6  1
 1.3333  .3333  6  1
  .3333-1.6667  6  1
-1.6667  .3333  6  1
 1.3333-1.6667  6  1
-1.6667 1.3333  6  1
 -.6667-1.6667  6  1
-1.6667 -.6667  6  1
 -.6667 2.3333  6  1
 2.3333 -.6667  6  1
-1.6667 2.3333  6  1
 2.3333-1.6667  6  1
 1.3333 1.3333  6  1
 1.3333-2.6667  6  1
-2.6667 1.3333  6  1
  .3333 2.3333  6  1
 2.3333  .3333  6  1
  .3333-2.6667  6  1
-2.6667  .3333  6  1
 2.3333-2.6667  6  1
-2.6667 2.3333  6  1
-1.6667-1.6667  6  1
-1.6667 3.3333  6  1
 3.3333-1.6667  6  1
 0.0020                 TST
  1  2  3  4  5  6  7  8  9 10 11 12 23 24 25 26 27 28   NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  1  1  0               IT1 IT2 IT3
 335.0000  63.5400   1.0000   1.0000   0.0000    THDB1 AM1 FPER1 FPAR1 DR01
 514.0000  26.9815   1.0000   1.0000   0.0000    THDB2 AM2 FPER2 FPAR2 DR02
   1.0000   1.0000   1.0000   1.0000   0.0000    THDB3 AM3 FPER3 FPAR3 DR03
 150.0000                                        TI TF DT
  5                     LMAX
  2                     NEL
  .3000
  .0183  .1099-3.2606  .0012  .0000  .0000  .0000  .0000  .0000  .0000 CU BURDIC
  .4310  .4735  .0580  .0022  .0000  .0000  .0000  .0000  .0000  .0000 AL SNOW
  .4000
 -.0719  .1382-3.2654  .0031  .0001  .0000  .0000  .0000  .0000  .0000
  .2949  .5694  .1131  .0053  .0002  .0000  .0000  .0000  .0000  .0000
  .5000
 -.1592  .1551-3.2727  .0064  .0003  .0000  .0000  .0000  .0000  .0000
  .1764  .6159  .1880  .0105  .0006  .0000  .0000  .0000  .0000  .0000
  .7500
 -.3593  .1547-3.2801  .0226  .0014  .0001  .0000  .0000  .0000  .0000
 -.0661  .6188  .4350  .0346  .0030  .0002  .0000  .0000  .0000  .0000
 1.0000
 -.5347  .1139-3.2688  .0533  .0042  .0003  .0000  .0000  .0000  .0000
 -.2563  .5609  .6869  .0754  .0087  .0009  .0000  .0000  .0000  .0000
 1.5000
 -.8266 -.0169-3.2149  .1641  .0186  .0019  .0002  .0000  .0000  .0000
 -.5402  .4212  .9996  .1938  .0340  .0048  .0005  .0000  .0000  .0000
 2.0000
-1.0598 -.1600-3.1638  .3252  .0491  .0067  .0007  .0001  .0000  .0000
 -.7464  .3027 1.1477  .3198  .0783  .0151  .0023  .0002  .0000  .0000
 3.0000
-1.4105 -.4112-3.1350  .6392  .1568  .0329  .0056  .0008  .0001  .0000
-1.0445  .1290 1.3072  .4921  .1904  .0594  .0144  .0027  .0004  .0000
 4.0000
-1.6676 -.6056-3.1564  .8445  .2866  .0848  .0200  .0037  .0006  .0001
-1.2693 -.0050 1.3854  .5931  .2798  .1209  .0416  .0112  .0023  .0004
 5.0000
-1.8737 -.7611-3.1826  .9921  .3944  .1517  .0468  .0114  .0022  .0003
-1.4509 -.1168 1.4219  .6690  .3407  .1756  .0785  .0279  .0078  .0017
 6.0000
-2.0495 -.8941-3.2074 1.1116  .4757  .2169  .0837  .0255  .0062  .0012
-1.6004 -.2092 1.4429  .7253  .3892  .2167  .1147  .0511  .0181  .0051
 7.0000
-2.2037-1.0125-3.2339 1.2054  .5428  .2714  .1243  .0461  .0136  .0032
-1.7274 -.2871 1.4553  .7662  .4307  .2496  .1446  .0759  .0329  .0114
  3  1  0               NLAY NST1 ISCAN
 0.0000 0.0000 0.0000   FPOS(1,J)
 0.0000 2.5560 0.0000   FPOS(2,J)
 0.0000 0.0000 0.0000   FPOS(3,J)
  3                     NVAR
 0.0000 5.1120 0.0000   VPOS(1,J)
-0.1000 5.1120 0.0000   VPOS(2,J)
-0.2000 5.1120 0.0000   VPOS(3,J)
  2                     NTAU
  1  1  2               LPS
  0                     NINV
  0  0  0               INV
 1.8870 0.0000-1.4757  1 0.0000 0.0000 0.0000  5 0.1000 0.0000 0.0000
  20.00 201.00   5.00   EI EF DE
 -10.00                 EI EF DE
C
C
C
C  --- M3.4.2
C
C     PROGRAM CUALM(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA CU(111)+(R3XR3)R30AL BULK ALLOY, M INV+RFS,(XZ) MIRR.PL.
C  MAIN LEED PROGRAM FOR A (R3XR3)R30 SUBSTITUTIONALLY ALLOYED FCC(111)
C  SURFACE, AL BEING INCORPORATED IN ALL ODD-NUMBERED LAYERS,
C  USING MATRIX INVERSION FOR THE POSSIBLY BUCKLED
C  3-ATOM/U.C. OVERLAYER. THE (XZ) PLANE IS MIRROR PLANE.
C  RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASV2(3),ASI(3,10),STPS(3,10,2),
     3NSTS(10,2),NRTNP(1),NRTP(2)
C  3=NL, 66=KLM
      COMPLEX VL(3,2),FLMS(3,66),FLM(66)
C  3=NL, 3=IDEG
      DIMENSION V(3,2),JJS(3,3)
C  2=KNBS=NO. OF BEAM SETS READ IN, 52=KNT=NO. OF BEAMS READ IN
      DIMENSION KNB(2),NB(2),SPQF(2,52),SPQ(2,52),PQF(2,52),PQ(2,52)
      INTEGER KSYM(2,52),SYM(2,52)
C  106 MUST BE .GE. NPUN
      DIMENSION NPU(106),NPUC(106)
C  12=NPSI, 12=NEL*(LMAX+1)
      DIMENSION ES(12),PHSS(12,12)
C  3(1ST DIM)=NLAY, 20,12,7 FIXED, 1820=NCAA FROM DATA STATEMENT
      DIMENSION FPOS(3,3),VPOS(20,3),LPS(12),INV(12),CAA(1820),NCA(7),
     1LPSS(12)
C  3=NLAY
      DIMENSION POS(3,3),POSS(3,3),MGH(3,3)
C  3=NLAY2
      DIMENSION DRL(3,3),SDRL(3,3),NUGH(3),NGEQ(3),NGOL(3),TEST(3)
C  1925=NLM FROM DATA STATEMENT, 121=NN, 11=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(1925),YLM(121),FAC2(121),FAC1(11)
C  11=NN1, 6=NN2, 6=NN3
      DIMENSION PPP(11,6,6)
C  36=LMMAX
      DIMENSION LX(36),LXI(36),LXM(36),LT(36)
C  6=LMAX+1=L1, 3 AND 10 FIXED FOR COMMON /MPT/
      COMPLEX AF(6),CAF(6),TSF0(3,10),TSF(3,10)
C  5408=2(=MO IN RFSG)*52*52(=NT*NT)
      COMPLEX ROP(5408),TOP(5408),ROM(5408),TOM(5408)
C  30=KNP
      COMPLEX RA1(52,30),TA1(52,30)
C  72=LMT, 216(IN GH)=LMG, 3(2ND DIM IN RG)=NLAY, 108(IN TS)=LMN,
C  216(IN TG)=LM2N, 108(IN TH,IPL)=LMNI
      COMPLEX TAU(72,21),TAUG(72),TAUGM(72),GH(216,36),RG(3,3,52),
     1TS(108),TG(2,216),VT(216),TH(108,108)
      DIMENSION IPL(108)
C  21=LEV, 42=LEV2, 15=LOD
      COMPLEX AMULT(52),CYLM(52,36),XEV(21,42),XOD(15,15),
     1YLME(21),YLMO(15)
      DIMENSION IPLE(21),IPLO(15),AT(52)
C  6=MNPP, 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(52),PK(52,8),AW(52,2),ANEW(52,20)
C  FOR CDC ONLY  *********************************
C     LEVEL 2, GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
C     COMMON /BIG/ GH,TH,TAU,XEV,XOD,ROP,TOP,ROM,TOM,RA1,TA1
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMP/IT1,IT2,IT3,TI,TF,DT,T01,DRPER1,DRPAR1,DR01,DRPER2,
     1DRPAR2,DR02,DRPER3,DRPAR3,DR03
      COMMON /MPT/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF
      COMMON/NST/NST1,ASI,STPS,NSTS,NACV
      COMMON/ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     *IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN
     * ,BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  170 FORMAT(3F7.4,2(I3,3F7.4))
  171 FORMAT(7H ASI = ,3F8.4,/,2(10X,7HNSTS = ,I3,8H STPS = ,3F8.4,/))
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY - ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
      WRITE(8,465)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  NPSI= NO.OF ENERGIES AT WHICH PHASE SHIFTS WILL BE READ IN
      READ(5,200)NPSI
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIN(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NPSI,ES,PHSS,L1)
      T0=T01
C  NLAY= NO. OF SUBPLANES IN COMPOSITE LAYER (0, IF NO COMP. LAYER)
      READ(5,200)NLAY,NST1,ISCAN
C  READ IN ADDITIONAL DATA FOR COMPOSITE LAYER
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,LMMAX,
     1LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      IF (NLAY.EQ.0) GO TO 630
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM- PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      IF (IT1+IT2+IT3) 640,650,640
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP. IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
      WRITE (8,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  CONSIDER SUBSTRATE LAYERS FIRST
C  PRODUCE ATOMIC T-MATRIX ELEMENTS
      CALL TSCATF(1,L1,ES,PHSS,NPSI,IT1,E,0.,PPP,NN1,NN2,NN3,DR01,
     1DRPER1,DRPAR1,T0,T,TSF0,TSF,AF,CAF)
      DRPER=DRPER2
      DRPAR=DRPAR2
      DR0=DR02
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. 1 REGISTRY- ID=1. NLL=NL=3 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST (NAA BEAMS)
  930 NAA = NB(1)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NAA,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
C  SECOND (AND 3RD) BEAM SET NEXT (NBB BEAMS. NOTE OFFSETS
C  NA=NS=NAA)
      NBB=NB(2)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,RA1,TA1,NBB,NT,NP,AMULT,CYLM,
     1PQ,SYM,NT,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
      CALL CMPRTL(RA1,NT,NP,3HRA1)
      CALL CMPRTL(TA1,NT,NP,3HTA1)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR OTHER ATOMS
      CALL TSCATF(2,L1,ES,PHSS,NPSI,IT2,E,0.,PPP,NN1,NN2,NN3,DR02,
     1DRPER2,DRPAR2,T0,T,TSF0,TSF,AF,CAF)
C  SET PARAMETERS FOR SUPERLATTICE BULK LAYER
C  ONLY 1 REGISTRY (ID=1), SUPERLATTICE LAYER SYMMETRIES (LAY=1),
C  +-X SYMMETRY (NOPT=2)
      NA=0
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=DCUTS
      EPSN=0.01
      NPERT=8
      NOPT=2
      NEW=1
      DO 932 I=1,NLAY
      DO 931 J=1,3
 
  931 AS(J)=FPOS(I,J)*0.529
      WRITE(6,430)AS
  932 WRITE(8,430)AS
      NOFF1=NT*NT+1
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE COMPOSITE
C  SUPERLATTICE BULK LAYER BY MATRIX INVERSION (MTINV) OR BY RSP (MPERTI)
      CALL MTINV(ROP(NOFF1),TOP(NOFF1),ROP,TOP,ROP,TOP,ROP,TOP,
     1ROP,TOP,ROP,TOP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,      CLM,NLM,FPOS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
C     CALL MPERTI(ROP(NOFF1),TOP(NOFF1),ROP,TOP,ROP,TOP,ROP,TOP,
C    1ROP,TOP,ROP,TOP,
C    1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
C    2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,FPOS,POSS,
C    3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
C    4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1   ,1  )
C     WRITE(6,415)
      NEW=-1
C  COPY ROP,TOP TO ROM,TOM
      CALL MATCOP(ROP(NOFF1),NT,ROP,NT,ROP,NT,ROP,NT,ROM(NOFF1),NT,1)
      CALL MATCOP(TOP(NOFF1),NT,TOP,NT,TOP,NT,TOP,NT,TOM(NOFF1),NT,1)
C
C
C  REPEAT FOR THE TOPMOST LAYER (NO +- SYMM., SO NOPT=1)
      NOPT=1
C  SCAN OVER STRUCTURES WITHIN OVERLAYER
      DO 975 IVAR=1,NVAR
      DO 934 I=1,NLAY
      DO 933 J=1,3
      POS(I,J)=FPOS(I,J)
      POS(1,J)=VPOS(IVAR,J)
  933 AS(J)=POS(I,J)*0.529
      WRITE(6,430)AS
  934 WRITE(8,430)AS
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE TOP COMPOSITE
C  LAYER BY MATRIX INVERSION (MTINV) OR BY RSP (MPERTI)
      CALL MTINV(ROP,TOP,ROM,TOM,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,
     1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
     2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,      CLM,NLM,POS,POSS,
     3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
C     CALL MPERTI(ROP,TOP,ROM,TOM,ROP,TOP,ROP,TOP,ROP,TOP,ROP,TOP,
C    1NT,NT,NT,AMULT,CYLM,PQ,SYM,NT,FLMS,NL,LX,LXI,LT,LXM,LMMAX,
C    2KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,POS,POSS,
C    3MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
C    4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1   ,1  )
C     WRITE(6,415)
C
C
C  NOW STACK LAYERS
      NRTNP(1)=1
      NRTP(1)=101
      NRTP(2)=2
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE
      DO 970 NSC=1,NACV
      CALL GEOMV(0,1,POS,NLAY,NSC,ASV)
      A=ASV(1)*0.529
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSG(ROP,TOP,ROM,TOM,RA1,TA1,RA1,TA1,NT,NP,2,1,NRTNP,1,NRTP,
     12,NT,NB,KNBS,XI,PQ,PK,8,AW,ANEW,20,ASV,ASA,1,6,0.003)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI), PRINT AND
C  PUNCH (NPNCH=1. PUNCH A ALSO FOR LATER IDENTIFICATION)
      CALL RINT(NT,XI,AT,PQ,PQF,SYM,VV,THETA,FI,MPU,NPUC,EEV,A,1)
  970 CONTINUE
  975 CONTINUE
C
C
      WRITE(8,370)E,EEV
      IF (IT1+IT2+IT3) 980,990,980
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
      STOP
      END
C
C  --- M3.5.1
C     PROGRAM RNACO(INPUT,OUTPUT,PUN,OUT,TAPE5=INPUT,TAPE6=OUTPUT,
C    1TAPE7=PUN,TAPE8=OUT)
C  MAIN+DATA FCC(111)+C(4x2)NA+CO,BSN+M INV+KSLA+RFS,(XZ) M.PL.
C  MAIN LEED PROGRAM FOR A C(4x2) 3 ATOM/UNIT CELL OVERLAYER ON A
C  FCC(111) SURFACE, WITH M INV AND KIN. SUBL. ADD.(KSLA) FOR
C  THE OVERLAYER. AN (XZ) MIRROR PLANE IS ASSUMED.
C  RENORMALIZED FORWARD SCATTERING IS USED TO STACK LAYERS.
C  BEAM SET NEGLECT IS APPLIED.
C  OVERLAYER IS HANDLED AS ONE KINEM. NA/CELL SUBLAYER AND ONE
C  CO SUBLAYER REQUIRING A MATRIX INVERSION CALCULATION.
C  READCL ENTERS CO INTERNAL STRUCTURE THROUGH FPOS,VPOS,
C  RELATIVE ADSPECIE POSITIONS THROUGH ASB.
      DIMENSION ARA1(2),ARA2(2),RAR1(2),RAR2(2),SS1(2),SS2(2),SS3(2),
     1SS4(2),ASA(3),AS(3),ARB1(2),ARB2(2),RBR1(2),RBR2(2),SO1(2),
     2SO2(2),SO3(2),ASB(3),ASV(3),ASI(3,10),STPS(3,10,2),
     3NSTS(10,2),ASS(3,1)
      DIMENSION DRPERI(6),DRPARI(6),DR0I(6),ITI(6),NPSI(6),AR(3,2,1),
     1AD(3,2,1),AL(3,1),NRTK(2,1),ML(2),NRTNP(1),NRTP(1)
C  4=NL, 66=KLM
      COMPLEX VL(4,2),FLMS(4,66),FLM(66)
C  4=NL, 2=IDEG
      DIMENSION V(4,2),JJS(4,2)
C  3=KNBS=NO. OF BEAM SETS READ IN, 67=KNT=NO. OF BEAMS READ IN
C  49=KNTB=KNB(1)+KNP
      DIMENSION KNB(3),NB(3),SPQF(2,67),SPQ(2,67),PQF(2,67),PQ(2,67)
      INTEGER KSYM(2,67),SYM(2,67),PQB(2,49),PQFB(2,49),SYMB(2,49),
     1 NBS(2)
C  106 MUST BE .GE. NPUN
      DIMENSION NPU(106),NPUC(106)
C  15,6,48 FIXED
      DIMENSION ES(15,6),PHSS(15,48)
C  2=NLAY, 20,7 FIXED, 1820=NCAA FROM DATA STATEMENT
      DIMENSION LPS(20),INV(20),FPOS(2,3)
      DIMENSION FPOSF(2,3),VPOS(20,3),LPS(20),INV(20),LPSS(20),NCA(7)
      DIMENSION CAA(1820)
C  2=NLAY
      DIMENSION POSS(2,3),MGH(2,2)
C  1=NLAY2
      DIMENSION DRL(1,3),SDRL(1,3),NUGH(1),NGEQ(1),NGOL(1)
      DIMENSION TEST(1)
C  1925=NLM FROM DATA STATEMENT, 121=NN, 11=N (FOR CELMG)
C  YLM IS ALSO USED, AS COMPLEX VECTOR OF SMALLER CORE SIZE, IN MSMF,ETC
      DIMENSION NLMS(7),CLM(1925),YLM(121),FAC2(121),FAC1(11)
C  11=NN1, 6=NN2, 6=NN3
      DIMENSION PPP(11,6,6)
C  36=LMMAX
      DIMENSION LX(36),LXI(36),LXM(36),LT(36)
C  6=LMAX+1=L1, 6 AND 10 FIXED FOR COMMON /MPTA/
      COMPLEX AF(6),CAF(6),TSF0(6,10),TSF(6,10)
C  49=KNTB
      COMPLEX RIP(49,49,2),TIP(49,49,2),RIM(49,49,2),TIM(49,49,2)
C 31=KNP
      COMPLEX RA1(49,31),TA1(49,31)
C  108=LMT, 72(IN GH)=LMGR, 2,2(2ND DIM IN RG)=NLAY, 72(IN TS)=LMN,
C  144(IN TG,VT)=LM2N, 108(IN TAUG,TAUGM)=LTAUG
C  72 (IN TH,IPL)=LMNI
      COMPLEX RG(3,2,49),VT(144),TS(72)
      COMPLEX TAU(108,1),TAUG(108),TAUGM(108),GH(72,36),
     1TG(2,144),TH(72,72)
C  21=LEV, 42=LEV2, 15=LOD
      COMPLEX AMULT(49),CYLM(49,36),XEV(21,42),XOD(15,15),
     1YLME(21),YLMO(15)
      DIMENSION IPLE(21),IPLO(15),AT(49),ATS(67,48),AAA(48),IPL(72)
C  8=MAX(MNPP,8), 20=ND (FOR RFS SUBROUTINES)
      COMPLEX XI(49),PK(49,16),AW(49,2),ANEW(49,20)
      COMMON E3,AK21,AK31,VPI1,TV,EMACH
      COMMON /X4/E,VPI,AK2,AK3,ASA
      COMMON  /SL/ARA1, ARA2, ARB1, ARB2, RBR1, RBR2, NL1, NL2
      COMMON /MS/LMAX,EPS,LITER,SO1,SO2,SO3,SS1,SS2,SS3,SS4
      COMMON  /ADS/ASL, FR, ASE, VPIS, VPIO, VO, VV
      COMMON /BT/IT,T,T0,DRPER,DRPAR,DR0
      COMMON /TEMPT/ES,PHSS,TI,TF,DT,T01,DRPERI,DRPARI,DR0I,ITI,NPSI
      COMMON /MPTA/NA,NS,ID,LAY,L1,NTAU,TSTS,TV1,DCUT,EPSN,NPERT,NOPT,
     1NEW,LPS,LPSS,INV,NINV,TSF,IAPX
      COMMON/NST/NST1,ASI,STPS,NSTS,NACV
      COMMON/ZMAT/IANZ(40),IZ(40,4),BL(40),ALPHA(40),BETA(40),NZ,
     *IPAR(15,5),NIPAR(5),NPAR,DX(5),NUM,NATOMS,ISCAN
     * ,BLS(40),ALPHAS(40),BETAS(40),PHIR,PHIM1,PHIM2
C  NCA IS DIMENSION OF CAA AS FUNCTION OF LMAX
      DATA NCA(1),NCA(2),NCA(3),NCA(4),NCA(5),NCA(6),NCA(7)/
     11,70,264,759,1820,3836,7344/
C  NLMS IS DIMENSION OF CLM AS FUNCTION OF LMAX
      DATA NLMS(1),NLMS(2),NLMS(3),NLMS(4),NLMS(5),NLMS(6),NLMS(7)/
     10,76,284,809,1925,4032,7680/
  161 FORMAT(3F7.2)
  170 FORMAT(3F7.4,2(I3,3F7.4))
  171 FORMAT(7H ASI = ,3F8.4,/,2(10X,7HNSTS = ,I3,8H STPS = ,3F8.4,/))
  200 FORMAT(20I3)
  240 FORMAT(8H0IDEG = ,1I3,7H NL1 = ,1I3,7H NL2 = ,1I3)
  370 FORMAT(9H1ENERGY =,F7.4,7H H  OR ,1F7.2,3H EV)
  380 FORMAT(8H VPIS = ,F9.4,8H VPIO = ,F9.4,9H DCUTS = ,F9.4,9H DCUTO =
     1 ,F9.4)
  390 FORMAT(8H0TEMP = ,F9.4)
  410 FORMAT(10H MSMF   OK)
  415 FORMAT(10H MPERTI OK)
  416 FORMAT(10H MTINV  OK)
  417 FORMAT(10H MKINY  OK)
  420 FORMAT(10H SUBREF OK)
  430 FORMAT(20H0SURFACE GEOMETRY   ,3F7.4)
  450 FORMAT(20H CORRECT TERMINATION)
  460 FORMAT(20A4)
  465 FORMAT(1H1,20A4)
C  FOR CRAY ONLY  ************************************
      CALL LINK("unit5=(data,open,text),
     1           unit6=(output,create,hc),
     2           unit7=(name7,create,text),
     3           unit8=(name8,create,hc)//")
C
C
C  READ, WRITE AND PUNCH A DESCRIPTIVE TITLE
      READ (5,460)(CLM(I),I=1,20)
      WRITE(6,465)(CLM(I),I=1,20)
      WRITE(7,460)(CLM(I),I=1,20)
      WRITE(8,465)(CLM(I),I=1,20)
C  EMACH IS MACHINE ACCURACY (USED BY ZGE AND ZSU)
      EMACH=1.0E-6
C  IDEG- EACH LAYER HAS AN IDEG-FOLD SYMMETRY AXIS
C  NL1, NL2- SUPERLATTICE CHARACTERIZATION  NL1  NL2
C                      P(1*1)                1    1
C                      C(2*2)                2    1
C                      P(2*1)                2    1
C                      P(1*2)                1    2
C                      P(2*2)                2    2
      READ(5,200)IDEG,NL1,NL2
      WRITE(6,240)IDEG,NL1,NL2
      NL=NL1*NL2
C  KNBS= NO.OF BEAM SETS TO BE READ IN (.LE.NL)
C  KNT= TOTAL NO. OF BEAMS TO BE READ IN
C  NPUN= NO. OF BEAMS FOR WHICH INTENSITIES ARE TO BE PUNCHED OUT
      READ(5,200)KNBS,KNT,NPUN
C  READ IN GEOMETRY, PHYSICAL PARAMETERS, CONVERGENCE CRITERIA
      CALL READIT(TVA,RAR1,RAR2,ASA,TVB,ASB,STEP,NSTEP,IDEG,NL,V,VL,
     1JJS,KNBS,KNB,KNT,SPQF,KSYM,SPQ,TST,TSTS,NPUN,NPU,THETA,FI,
     2LMMAX,NATH,L1)
      T0=T01
C  READ IN ADDITIONAL DATA FOR ONE SUBLAYER OF COMPOSITE LAYER
C  NLAY= NO. OF SUBPLANES IN ONE SUBLAYER OF COMPOSITE LAYER
C  NST1= NO. OF SETS OF GEOMETRIES IN SCAN OVER INTERLAYER VECTORS (SEE
C        ROUTINE GEOMV)
C  ISCAN= NO. OF GEOMETRIES IN SCAN OVER MOLECULAR STRUCTURES
C         (SEE ROUTINE GEOMV)
      READ(5,200)NLAY,NST1,ISCAN
      CALL READCL(NLAY,NLAY2,FPOS,VPOS,NVAR,NTAU,LPS,NINV,INV,
     1LMMAX,LMG,LMN,LM2N,LMT,LTAUG,LMNI,LMNI2)
      KLM=(2*LMAX+1)*(2*LMAX+2)/2
      LEV=(LMAX+1)*(LMAX+2)/2
      LOD=LMMAX-LEV
      LEV2=2*LEV
      NCAA=NCA(LMAX)
C  CAA= CLEBSCH-GORDON COEFFICIENTS FOR COMPOSITE LAYER
      CALL CAAA(CAA,NCAA,LMMAX)
  630 N=2*LMAX+1
      NN=N*N
      NLM=NLMS(LMAX)
C  CLM= CLEBSCH-GORDON COEFFICIENTS FOR MATRICES X AND TAU
      CALL CELMG(CLM,NLM,YLM,FAC2,NN,FAC1,N,LMAX)
C  LX,LXI,LT,LXM  PERMUTATIONS OF (L,M)-SEQUENCE
      CALL LXGENT(LX,LXI,LT,LXM,LMAX,LMMAX)
      DO 635 I=1,NATH
  635 IF (ITI(I).EQ.1) GO TO 640
      GO TO 650
  640 NN3=LMAX+1
      NN2=LMAX+1
      NN1=NN2+NN3-1
C  PPP= CLEBSCH-GORDON COEFFICIENTS FOR COMPUTATION OF TEMPERATURE-
C  DEPENDENT PHASE SHIFTS (SKIPPED IF NOT NEEDED)
      CALL  CPPP (PPP, NN1, NN2, NN3)
  650 CONTINUE
C
C
C  READ ENERGY RANGE AND STEP; IF EF AND DE ARE BLANK, PROGRAM COMPUTES
C  FOR ENERGY EI. PROGRAM ALWAYS RETURNS TO THIS LINE TO READ A NEW
C  ENERGY RANGE AND STEP. IF A NEGATIVE EI IS READ, RUN IS TERMINATED
  680 READ (5,161)  EI, EF, DE
      IF (EI)  1000, 690, 690
  690 EI=EI/27.21+VV
      EF=EF/27.21+VV
      DE=DE/27.21
      E = EI
      EC = E
      E3 = E
C
C
C  START LOOP OVER ENERGIES IN GIVEN ENERGY RANGE
  700 EEV=(E-VV)*27.21
      WRITE (6,370)  E,EEV
      WRITE (8,370)  E,EEV
C  COMPUTE COMPONENTS OF INCIDENT WAVEVECTOR PARALLEL TO SURFACE
      AK=SQRT(2.0*(E-VV))*SIN(THETA)                                    021178
      AK2=AK*COS(FI)
      AK3=AK*SIN(FI)
      AK21=AK2
      AK31=AK3
C  SELECT BEAMS APPROPRIATE FOR CURRENT ENERGY
      CALL BEAMS(KNBS,KNB,SPQ,SPQF,KSYM,KNT,NPU,NPUN,AK2,AK3,E,TST,
     1NB,PQ,PQF,SYM,NPUC,MPU,NT,NP)
C  SET OPTICAL POTENTIAL (IMAGINARY PART OF MUFFIN-TIN CONSTANT,
C  REPRESENTING DAMPING). VPIS FOR SUBSTRATE, VPIO FOR OVERLAYER.
C  HERE VPIS=VPIO PROPORTIONAL TO E**1/3
      VPIS=-(3.8/27.21)*EXP((ALOG((E)/(90.0/27.21+VV)))*0.333333)
      VPIO=VPIS
      DCUTO = SQRT(2.0 * E)
C  SET LIMITING RADII ON LATTICE SUMS, POSSIBLY DIFFERENT FOR SUBSTRATE
C  (DCUTS) AND OVERLAYER (DCUTO)
      DCUTS =  - 5.0 * DCUTO/(AMIN1(VPIS, - 0.05))
      DCUTO =  - 5.0 * DCUTO/(AMIN1(VPIO, - 0.05))
      WRITE (6,380)  VPIS, VPIO, DCUTS, DCUTO
C  FIX TEMPERATURE T. T MAY BE INCREASED STEPWISE IN A LOOP OVER THE
C  INPUT RANGE (TI,TF) WITH INPUT STEP DT
  770 T = TI
  780 WRITE (6,390)  T
C
C
      VPI1 = VPIO
C  PERFORM PLANAR LATTICE SUMS IN FMAT. ASSUME SAME MUFFIN-TIN CONSTANTS
C  AND DAMPINGS IN SUBSTRATE AND ADLAYER
      NLS=NL
      CALL  FMAT (FLMS, V, JJS, NL, NLS, DCUTO, IDEG, LMAX,KLM)
C
C
C  PRODUCE ATOMIC T-MATRIX ELEMENTS FOR ADATOMS
      E=EC-VO
      E3=E
      CALL TSCATT(2,1,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(2),DRPERI(2),DRPARI(2),T0,T,TSF0,TSF,AF,CAF)
      CALL TSCATT(3,2,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(3),DRPERI(3),DRPARI(3),T0,T,TSF0,TSF,AF,CAF)
      CALL TSCATT(4,3,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(4),DRPERI(4),DRPARI(4),T0,T,TSF0,TSF,AF,CAF)
c     call iMPRT(npsi,1,6,4hnpsi)
c     call iMPRT(iti,1,6,3hiti)
c     call rMPRT(dr0i,1,6,4hdr0i)
c     call rMPRT(drperi,1,6,6hdrperi)
c     call rMPRT(drpari,1,6,6hdrpari)
c     call cMPRT(tsf0,6,10,4htsf0)
c     call cMPRT(tsf,6,10,3htsf)
c     call cMPRT(af,1,6,2haf)
c     call cMPRT(caf,1,6,3hcaf)
C
C
C  CONSIDER SUBSTRATE LAYERS
C  PRODUCE ATOMIC T-MATRIX ELEMENTS.
C  AF AND CAF ARE OVERWRITTEN, BUT NOT TSF0 AND TSF
      E=EC
      E3=E
      CALL TSCATT(1,4,L1,ES,PHSS,NPSI,ITI,E,0.,PPP,NN1,NN2,NN3,
     1DR0I(1),DRPERI(1),DRPARI(1),T0,T,TSF0,TSF,AF,CAF)
c     call cMPRT(tsf,6,10,3htsf)
      DRPER=DRPERI(1)
      DRPAR=DRPARI(1)
      DR0=DR0I(1)
      IT=0
      TV = TVA
      VPI = VPIS
      VPI1 = VPIS
C
C
C  APPLY BSN APPROXIMATION
C
C  PRODUCE REFLECTION (RA1) AND TRANSMISSION (TA1) MATRICES FOR
C  ATOMIC LAYERS. 1 REGISTRY- ID=1. NLL=NL=4 SUBLATTICES. SUBSTRATE
C  LAYER SYMMETRIES AND REGISTRIES APPLY- LAY=2. TEMPERATURE-DEPENDENT
C  PHASE SHIFTS- CAF
C  FIRST BEAM SET FIRST- INT.-ORDER BEAMS (NAA BEAMS)
      NAA = NB(1)
      NAA1=NAA+1
      NTP=NB(1)+NP
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,
     1RA1,TA1,NAA,NTP,NP,AMULT,CYLM,
     1PQ,SYM,NAA,FLMS,FLM,V,NL,  0,  0,1,NL,CAF,CAF,L1,LX,LXI,LMMAX,KLM,
     2XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,CLM,NLM,2)
      WRITE (6,410)
c     call cMPRT(tsf,6,10,3htsf)
C  START BSN LOOP OVER FRACT.-ORDER BEAM SETS (NORMALLY STARTS WITH
C  NBSN=2)
      DO 978 NBSN=2,KNBS
      WRITE(6,892)NBSN,KNBS
      WRITE(8,892)NBSN,KNBS
  892 FORMAT(13H0BSN LOOP NO.,1I3,7H OUT OF,1I3,6H LOOPS)
C  IAPX WILL BE USED BY MPERTA/MTINVA, AFTER MODIFICATION BY BSN1
      IAPX=2
      CALL BSN1(NBSN,PQ,PQF,SYM,NT,PQB,PQFB,SYMB,NTB,NB,KNBS,NBS,IAPX)
      IF (NBSN.EQ.1) GO TO 900
C
C
C  NEXT, REFLECTION AND TRANSMISSION MATRICES FOR SUBSTRATE LAYERS FOR
C  ONE FRACT.-ORDER BEAM SET (MAY BE SYMMETRIZED)
      NBB=NB(NBSN)
      CALL MSMF(RA1,TA1,RA1,TA1,RA1,TA1,
     1RA1,TA1,NBB,NTP,NP,AMULT(NAA1),
     1CYLM(NAA1,1),PQB,SYMB,NTP,FLMS,FLM,V,NL,NAA,NAA,1,NL,CAF,CAF,L1,
     2LX,LXI,LMMAX,KLM,XEV,XOD,LEV,LOD,YLM,YLME,YLMO,IPLE,IPLO,
     3CLM,NLM,2)
      WRITE (6,410)
C
C
C  SET PARAMETERS FOR COMPOSITE OVERLAYER
C  ONLY 1 REGISTRY (ID=1), OVERLAYER SYMMETRIES (LAY=1)
  900 NA=NAA
      IF (NBSN.EQ.1) NA=0
      E=EC-VO
      E3=E
      NS=0
      ID=1
      LAY=1
      TV1=TVB
      DCUT=2.0/0.529
      EPSN=0.01
      NPERT=5
C
C  START WITH NA SUBLAYER, BY KINEMATICAL APPROXIMATION
      NOPT=2
      DO 915 I=1,1
      DO 916 J=1,3
  916 FPOSF(I,J)=0.0
  915 LPS(I)=3
C
C  COMPUTE REFLECTION AND TRANSMISSION MATRICES FOR THE NA SUB-
C  LAYER
      CALL MKINY(RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
     1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,
     2LT,LXM,LMMAX,LEV,
     3FPOS,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,
     4RG,TS,LMN,TG,VT)
      WRITE(6,417)
c     call iMPRT(NTB,1,1,3hNTB)
c     call iMPRT(ntp,1,1,2hntp)
c     call iMPRT(nugh,1,nlay2,4hnugh)
c     call iMPRT(ngeq,1,nlay2,4hngeq)
c     call iMPRT(ngol,1,nlay2,4hngol)
c     call iMPRT(mgh,nlay,nlay,3hmgh)
c     call rMPRT(pqb,2,ntp,3hpqb)
c     call rMPRT(drl,nlay2,3,3hdrl)
c     call rMPRT(sdrl,nlay2,3,4hsdrl)
c     call cMPRT(rip,ntp,ntp,4hrip1)
c     call cMPRT(tip,ntp,ntp,4htip1)
c     call cMPRT(rim,ntp,ntp,4hrim1)
c     call cMPRT(tim,ntp,ntp,4htim1)
c     call cMPRT(amult,ntp,1,5hamult)
c     call cMPRT(cylm,ntp,2,4hcylm)
c     call cMPRT(tau,lmt,1,3htau)
c     call cMPRT(gh,lmg,2,2hgh)
c     call cMPRT(rg,18,4,2hrg)
c     call cMPRT(th,lmni,4,2hth)
C
C
C  NEXT CO SUBLAYER, GEOMETRY DEFINED BY FPOS
      NOPT=1
      NINV=0
      NSTR=0
      DO 975 IVAR=1,NVAR
      DO 910 I=1,NLAY
      DO 910 J=1,3
  910 FPOSF(I,J)=FPOS(I,J)+VPOS(I,J)
      CALL RMPRT(FPOSF,NLAY,3,5HFPOSF)
c     call rMPRT(phss,15,48,4hphss)
c     call cMPRT(tsf,6,10,3htsf)
C  COMPUTE REFL. AND TRANSM. MATRICES FOR ONE SUBLAYER WITH PARTIAL
C  MULT. SCATT. (MPERTA) OR FULL MULT. SCATT. (MTINVA)
      MOFF2=NTP*NTP+1
C     CALL MPERTA(RIP(MOFF2,1,1),TIP(MOFF2,1,1),RIM(MOFF2,1,1),TIM(MOFF2,1,1),
C    1RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
C    1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
C    2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,LTAUG,CLM,NLM,
C    3FPOSF,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
C    4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,1,1)
C     WRITE(6,415)
      CALL MTINVA(RIP(MOFF2,1,1),TIP(MOFF2,1,1),
     1RIM(MOFF2,1,1),TIM(MOFF2,1,1),
     1RIP,TIP,RIP,TIP,RIP,TIP,RIP,TIP,
     1NTB,NTP,NTP,AMULT,CYLM,PQB,SYMB,NTB,FLMS,NL,LX,LXI,
     2LT,LXM,LMMAX,KLM,XEV,LEV,LEV2,TAU,LMT,TAUG,TAUGM,CLM,NLM,
     3FPOSF,POSS,MGH,NLAY,DRL,SDRL,NUGH,NGEQ,NGOL,NLAY2,TEST,
     4GH,LMG,RG,TS,LMN,TG,LM2N,VT,CAA,NCAA,TH,LMNI,IPL)
      WRITE(6,416)
c     call rMPRT(phss,15,48,4hphss)
c     call cMPRT(tsf,6,10,3htsf)
c     call iMPRT(NTB,1,1,3hNTB)
c     call iMPRT(ntp,1,1,3hntp)
c     call iMPRT(nugh,1,nlay2,4hnugh)
c     call iMPRT(ngeq,1,nlay2,4hngeq)
c     call iMPRT(ngol,1,nlay2,4hngol)
c     call iMPRT(mgh,nlay,nlay,3hmgh)
c     call rMPRT(pqb,2,ntp,3hpqb)
c     call rMPRT(drl,nlay2,3,3hdrl)
c     call rMPRT(sdrl,nlay2,3,4hsdrl)
c     call cMPRT(rip(moff2,1,1),ntp,ntp,4hrip2)
c     call cMPRT(tip(moff2,1,1),ntp,ntp,4htip2)
c     call cMPRT(rim(moff2,1,1),ntp,ntp,4hrim2)
c     call cMPRT(tim(moff2,1,1),ntp,ntp,4htim2)
c     call cMPRT(amult,ntp,1,5hamult)
c     call cMPRT(cylm,ntp,2,4hcylm)
c     call cMPRT(tau,lmt,1,3htau)
c     call cMPRT(gh,lmg,2,2hgh)
c     call cMPRT(rg,18,4,2hrg)
c     call cMPRT(th,lmni,4,2hth)
C
C
C  SCAN OVER STRUCTURES WITHIN COMPOSITE OVERLAYER BY KINEMATIC ADDITION
C  OF SUBLAYERS (LOOP 972)
      ML(1)=2
      ML1=ML(1)
      NRTK(1,1)=-2
      NRTK(2,1)=1
      NRTNP(1)=-1
      NRTP(1)=101
      DO 930 J=1,3
      AD(J,1,1)=0.0
      AD(J,2,1)=0.0
      AR(J,1,1)=0.0
C  ASB POINTS FROM NA POSITION TO C POSITION
      AR(J,2,1)=ASB(J)
  930 CONTINUE
      AD(1,1,1)=FPOSF(1,1)-FPOSF(2,1)
      DO 972 ISTEP=1,NSTEP
      AR(1,2,1)=ASB(1)+(ISTEP-1)*STEP
      A=0.
      IK=1
      DO 935 I=1,ML1
      AP=AR(1,I,1)+AD(1,I,1)
      IF (AP.LT.A) GO TO 935
      IK=I
      A=AP
  935 CONTINUE
      DO 940 J=1,3
  940 AL(J,1)=0.
      AL(1,1)=A
      CALL RMPRT(AR,3,ML1,2HAR)
      CALL RMPRT(AD,3,ML1,2HAD)
      CALL RMPRT(AL,1,3,2HAL)
C
C
C  NOW STACK LAYERS
      NLR=2
      IF (NBSN.EQ.1) NLR=1
C  SUBSTRATE INTERLAYER VECTORS
      DO 950 I=1,3
      DO 950 J=1,1
  950 ASS(I,J)=ASA(I)
C  ASV BECOMES VECTOR BETWEEN OVERLAYER AND SUBSTRATE
      NST1=NST1F
      DO 970 NSC=1,NACV
      CALL GEOMV(0,1,FPOSF,NLAYF,NSC,ASV)
      A=ASV(1)*0.529
C
C  COMPUTE REFLECTED BEAM AMPLITUDES BY RFS
      CALL RFSK(RIP,TIP,RIM,TIM,RIP,TIP,RIM,TIM,RA1,TA1,RA1,TA1,NTP,NP,
     11,1,2,NRTNP,1,
     2NRTP,1,NTB,NBS,NLR,XI,PQB,PK,16,AW,ANEW,20,ASV,ASS,1,6,0.003,
     3ML,NRTK,2,AR,AD,AL)
C  COMPUTE REFLECTED INTENSITIES (AT) FROM AMPLITUDES (XI) AND PRINT
      CALL RINT(NTB,XI,AT,PQB,PQFB,SYMB,VV,THETA,FI,MPU,NPUC,EEV,
     1A,0)
C  STORE INTENSITIES AT IN ATS FOR LATER PUNCHING BY RINTB
      NSTRUC=24
      NSTR=NSTR+1
      IF (NSTR.LE.NSTRUC) GO TO 966
      WRITE(6,965)NSTR,NSTRUC
      WRITE(8,965)NSTR,NSTRUC
C     STOP
      CALL EXIT
  965 FORMAT(31H *** TOO MANY STRUCTURES, NSTR=,I4,9H, NSTRUC=,I4)
  966 CONTINUE
      CALL BSN2(NBSN,NSTR,NB,KNBS,NBS,AT,NTB,ATS,NT,NSTRUC,A,AAA)
  970 CONTINUE
  972 CONTINUE
C  END OF BSN LOOP, FOLLOWING END OF STRUCTURE LOOP(S)
  978 CONTINUE
C  PUNCH OUT INTENSITIES IN STANDARD NON-BSN SEQUENCE
      DO 979 ISTR=1,NSTR
  979 CALL RINTB(NT,ATS,NT,NSTRUC,ISTR,MPU,NPUC,EEV,AAA)
C
C
  985 WRITE(8,370)E,EEV
      DO 981 I=1,NATH
  981 IF (ITI(I).EQ.1) GO TO 980
      GO TO 990
  980 T = T + DT
      IF (DT.LE.0.0001) GO TO 990
      IF (T-TF)  780, 780, 990
  990 E = E + DE
      EC = E
      E3 = E
      IF (E-EF)  700, 700, 680
 1000 WRITE (6,450)
C     STOP
      CALL EXIT
      END
 RH(111)+C(4x2)NA(BABC)+CO(CABC),(XZ)MIRR PL,M INV+BSN+KSLA,6PS
  2  4  1               IDEG NL1 NL2
  3 67 27               KNBS KNT NPUN
 1.3424-2.3251          ARA1
 1.3424 2.3251          ARA2
 0.0000 0.0000          SS1
 0.0000 0.0000          SS2
 0.0000 0.0000          SS3
 0.0000 0.0000          SS4
 2.1921 0.0000-1.5501   ASA
 5.3696 0.0000          ARB1 
 0.0000 4.6502          ARB2
 0.0000 0.0000          SO1
 0.0000 0.0000          SO2
 0.0000 0.0000          SO3
 0.8000 2.6848-1.5501   ASB
 0.5000 1.6000 0.2000   FR ASE STEP
  6                     NSTEP
 18                     KNB(1)
 0.     0.      1  1
 0.     1.0000  6  6
 0.    -1.0000  6  6
-1.0000 1.0000  1  1
 1.0000-1.0000  1  1
 1.0000 1.0000  6  6
-1.0000 2.0000  6  6
 1.0000-2.0000  6  6
 0.     2.0000  6  6
 0.    -2.0000  6  6
-2.0000 2.0000  1  1
 2.0000-2.0000  1  1
 1.0000 2.0000  6  6
-1.0000-2.0000  6  6
-1.0000 3.0000  6  6
 1.0000-3.0000  6  6
-2.0000 3.0000  6  6
 2.0000-3.0000  6  6
 31                     KNB(2)
  .2500  .2500  6  1
 -.7500  .2500  6  1
  .2500 -.7500  6  1
 -.7500 1.2500  6  1
 1.2500 -.7500  6  1
 -.7500 -.7500  6  1
  .2500 1.2500  6  1
 1.2500  .2500  6  1
-1.7500 1.2500  6  1
 1.2500-1.7500  6  1
-1.7500  .2500  6  1
  .2500-1.7500  6  1
 -.7500 2.2500  6  1
 2.2500 -.7500  6  1
-1.7500 2.2500  6  1
 2.2500-1.7500  6  1
 1.2500 1.2500  6  1
-1.7500 -.7500  6  1
 -.7500-1.7500  6  1
  .2500 2.2500  6  1
 2.2500  .2500  6  1
-2.7500 1.2500  6  1
 1.2500-2.7500  6  1
-2.7500 2.2500  6  1
 2.2500-2.7500  6  1
-2.7500  .2500  6  1
  .2500-2.7500  6  1
-1.7500 3.2500  6  1
 3.2500-1.7500  6  1
 -.7500 3.2500  6  1
 3.2500 -.7500  6  1
 18                     KNB(3)
 -.5000  .5000  1  1
  .5000 -.5000  1  1
  .5000  .5000  6  6
 -.5000 1.5000  6  6
  .5000-1.5000  6  6
-1.5000 1.5000  1  1
 1.5000-1.5000  1  1
  .5000 1.5000  6  6
 -.5000-1.5000  6  6
-1.5000 2.5000  6  6
 1.5000-2.5000  6  6
 -.5000 2.5000  6  6
  .5000-2.5000  6  6
-2.5000 2.5000  1  1
 2.5000-2.5000  1  1
 1.5000 1.5000  6  6
  .5000 2.5000  6  6
 -.5000-2.5000  6  6
 0.0020                     TST
  1  2  3  4  5  6  7  8  9 10 11 12 19 20 21 22 23 24 25 26 50 51 52 53 54 55
 56                              NPU
   0.00   0.00          THETA FI
   0.00  10.00          VO VV
 0.0010                 EPS
  5                     LITER
  4                     NATH
  1  1  1  1            IT
 480.0000 102.9050   1.4000   1.4000   0.0000    THDB AM FPER FPAR DR0
1404.9675  12.0112   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
1217.3280  15.9994   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
1015.5235  22.9900   2.0000   2.0000   0.0000    THDB AM FPER FPAR DR0
  30.0000                                        TI TF DT
  5                     LMAX
  4                     NEL
 12  RH                 NPSI
  .3000
 -.5534 -.1344 2.6414  .0033  .0001  .0000  .0000  .0000  .0000  .0000  RH
  .4000
 -.6591 -.1824 2.7179  .0086  .0003  .0000  .0000  .0000  .0000  .0000
  .5000
 -.7564 -.2288 2.7117  .0178  .0007  .0000  .0000  .0000  .0000  .0000
  .7500
 -.9739 -.3398 2.6526  .0658  .0038  .0002  .0000  .0000  .0000  .0000
 1.0000
-1.1643 -.4468 2.5964  .1653  .0115  .0009  .0001  .0000  .0000  .0000
 1.5000
-1.4863 -.6518 2.5183  .5829  .0493  .0057  .0005  .0000  .0000  .0000
 2.0000
-1.7495 -.8414 2.4632 1.1648  .1250  .0191  .0025  .0003  .0000  .0000
 3.0000
-2.1541-1.1623 2.3520 1.8562  .3605  .0845  .0171  .0028  .0004  .0000
 4.0000
-2.4546-1.4114 2.2346 2.1704  .5922  .1932  .0545  .0125  .0023  .0003
 5.0000
-2.6965-1.6116 2.1309 2.3333  .7747  .3079  .1132  .0340  .0082  .0016
 6.0000
-2.9033-1.7827 2.0421 2.4319  .9278  .4063  .1797  .0678  .0206  .0051
 7.0000
-3.0845-1.9347 1.9614 2.5025 1.0553  .4913  .2416  .1088  .0405  .0121
 12C/CO                 NPSI
  .3000
 1.5917-3.9436  .0031  .0000  .0000  .0000  .0000  .0000  .0000  .0000  C(CO)
  .4000
 1.4461-3.9485  .0062  .0001  .0000  .0000  .0000  .0000  .0000  .0000
  .5000
 1.3281-3.9767  .0108  .0002  .0000  .0000  .0000  .0000  .0000  .0000
  .7500
 1.1005-4.0665  .0290  .0007  .0000  .0000  .0000  .0000  .0000  .0000
 1.0000
  .9270-4.1547  .0584  .0017  .0000  .0000  .0000  .0000  .0000  .0000
 1.5000
  .6625-4.3074  .1544  .0064  .0002  .0000  .0000  .0000  .0000  .0000
 2.0000
  .4596-4.4309  .2967  .0160  .0008  .0000  .0000  .0000  .0000  .0000
 3.0000
  .1540-4.6112  .6224  .0555  .0040  .0002  .0000  .0000  .0000  .0000
 4.0000
 -.0708-4.7234  .8338  .1262  .0121  .0009  .0001  .0000  .0000  .0000
 5.0000
 -.2423-4.7849  .9157  .2238  .0277  .0026  .0002  .0000  .0000  .0000
 6.0000
 -.3743-4.8110  .9283  .3326  .0524  .0060  .0005  .0000  .0000  .0000
 7.0000
 -.4760-4.8175  .9108  .4326  .0871  .0118  .0012  .0001  .0000  .0000
 12O/CO                 NPSI
  .3000
-1.1163 -.4218  .0014  .0000  .0000  .0000  .0000  .0000  .0000  .0000  O(CO)
  .4000
-1.2556 -.4845  .0029  .0000  .0000  .0000  .0000  .0000  .0000  .0000
  .5000
-1.3712 -.5393  .0051  .0001  .0000  .0000  .0000  .0000  .0000  .0000
  .7500
-1.5981 -.6541  .0137  .0002  .0000  .0000  .0000  .0000  .0000  .0000
 1.0000
-1.7720 -.7485  .0278  .0006  .0000  .0000  .0000  .0000  .0000  .0000
 1.5000
-2.0353 -.9003  .0749  .0023  .0001  .0000  .0000  .0000  .0000  .0000
 2.0000
-2.2350-1.0203  .1500  .0059  .0002  .0000  .0000  .0000  .0000  .0000
 3.0000
-2.5333-1.1996  .3759  .0213  .0011  .0000  .0000  .0000  .0000  .0000
 4.0000
-2.7534-1.3232  .6301  .0513  .0035  .0002  .0000  .0000  .0000  .0000
 5.0000
-2.9246-1.4062  .8174  .0984  .0085  .0006  .0000  .0000  .0000  .0000
 6.0000
-3.0610-1.4581  .9203  .1622  .0169  .0014  .0001  .0000  .0000  .0000
 7.0000
-3.1710-1.4869  .9645  .2385  .0297  .0028  .0002  .0000  .0000  .0000
 15  Na                 NPSI
   0.32
-0.4126 0.0093 0.0651 0.0047 0.0003 0.0000 0.0000 0.0000 0.0000 0.0000
   0.46
-0.5536-0.0058 0.1373 0.0134 0.0014 0.0001 0.0000 0.0000 0.0000 0.0000
   0.63
-0.6984-0.0350 0.2411 0.0300 0.0041 0.0005 0.0001 0.0000 0.0000 0.0000
   0.83
-0.8424-0.0772 0.3654 0.0564 0.0097 0.0016 0.0002 0.0000 0.0000 0.0000
   1.05
-0.9827-0.1293 0.4912 0.0932 0.0190 0.0038 0.0007 0.0001 0.0000 0.0000
   1.30
-1.1171-0.1878 0.6022 0.1390 0.0330 0.0078 0.0018 0.0003 0.0001 0.0000
   1.58
-1.2441-0.2489 0.6929 0.1904 0.0519 0.0138 0.0037 0.0009 0.0002 0.0000
   1.88
-1.3628-0.3090 0.7665 0.2427 0.0759 0.0223 0.0066 0.0019 0.0005 0.0001
   2.21
-1.4736-0.3660 0.8285 0.2914 0.1040 0.0337 0.0108 0.0035 0.0011 0.0003
   2.96
-1.6771-0.4709 0.9279 0.3731 0.1635 0.0659 0.0239 0.0088 0.0034 0.0012
   3.81
-1.8628-0.5695 0.9968 0.4423 0.2155 0.1048 0.0457 0.0180 0.0074 0.0033
   4.76
-2.0300-0.6593 1.0486 0.4989 0.2624 0.1401 0.0729 0.0337 0.0141 0.0063
   5.83
-2.1807-0.7389 1.0882 0.5431 0.3046 0.1731 0.0980 0.0537 0.0260 0.0114
   7.00
-2.3201-0.8131 1.1152 0.5818 0.3386 0.2049 0.1221 0.0722 0.0412 0.0207
   7.63
-2.3857-0.8479 1.1260 0.5987 0.3539 0.2188 0.1344 0.0811 0.0485 0.0266
  2  1  0               NLAY NST1 ISCAN
 0.0000 0.0000 0.0000   FPOS(1,J)
-1.1500 0.0000 0.0000   FPOS(2,J)
  1                     NVAR
 0.0000 0.0000 0.0000   VPOS(1,J)
  3                     NTAU
  1  2                  LPS
  2                     NINV NLAY2R
  0  0                  INV
 1.1000 0.0000-1.5501  1 0.0000 0.0000 0.0000  3 0.1000 0.0000 0.0000
  20.00  26.00   5.00   EI EF DE
 -10.00                 EI EF DE

